/* --------------------------------------- Utilities  ---------------------------------*/
function ___Utilities_____(){}
var g_pluginName="TabTree";
function ___CTabNode_______(){}
function getActualURL(url)
{
	if(url==null)return '';
	url=url.toLowerCase();
	var idx=url.indexOf('#http://',0);
	if(idx>=0) return url.substr(idx+1);
	return url;
}

function sortFunc_domainA(n1,n2){return sortFuncBase(n1,n2,'Domain',1);}

function CTabNode(title,tree)
{
//constructor
	this.base=CTreeNode;
	this.base(title,tree);
	this.lastModified=null;
	this.readyState=null;
	this.oTab=null;
	this.cachedTabID=null;
	this.bReady=false;
	this.isActive=false;
	this.autoRefreshPeriod=-1;
	this.autoRefreshTimerID=null;
	this.ExtraStr='';
	this.bUnread=1;
	this.oldTitle=this.Title;
	this.bAutoReferrer=0;
	this.Tree.bTreeChanged=true;
	this.Domain=null;
	this.bMarked=false;
	this.bDomainGroup=false;

//"virtual" functions
//	this.v_isHidden=function(){return false;}
//	this.v_isDroppable=function(pos){return true;}
//	this.v_isDraggable=function(){return (this.Parent!=null);}
	this.v_getFilterStr=function()
	{
		if(this.Tree.bUseFilter && this.URL && this.autoRefreshPeriod<0)
		{
		return "Mask(Color=#FFFFFF) Chroma(Color=#000000) Mask(Color=#"+(this.bUnread?g_tabIconUnreadColor:g_tabIconReadColor)+") Chroma(Color=#FFFFFF)";
		}
		else return '';
	}
	this.v_getNodeText=function()
	{
		function processDomainTitle(tstr)
		{
			tstr=tstr.toLowerCase();
			var idx=tstr.indexOf('www.')
			if(idx==0) tstr=tstr.substr(4);
			var key,str,sublen,slen=tstr.length;
			for(key in g_arrDomainPostfix)
			{
				str=g_arrDomainPostfix[key];
				sublen=str.length;	
				tt=tstr.substr(slen-sublen);
				if(tt==str)
				{
					tstr=tstr.substr(0,slen-sublen);
					break;
				}
			}
			return tstr;
		}
		var ttitle;
		ttitle=this.Title;
		if(ttitle=='untitled' || ttitle=='localfile') ttitle=Trans(ttitle);	
		if(this.bDomainGroup && this.Tree.bShortDomain)
		{
			ttitle=processDomainTitle(ttitle);
		}
		return ttitle;
	}
	this.v_getToolTip=function()
	{
		if(!this.Tree.bTabTooltip) return '';
		var str='';
		var ttitle=unescape(this.Title)+this.v_getExtraStr();
		if(!(this.URL))
		{
			if(this.bDomainGroup) 	str+='['+Trans('domain')+']'+ttitle;
			else			str+='['+Trans('usergroup')+']'+ttitle;
		}
		else
		{
			if(this.hasChild()) str+='['+Trans('referrer')+']';
			else			str+='['+Trans('tab')+']';
			str+=ttitle+'\n';
			str+='['+Trans('url')+']'+':'+this.URL+'\n';
			str+='['+Trans('lastModified')+']'+':'+this.lastModified;
		}
		return str;
	}
	this.v_getExtraStr=function()
	{
		if(this.bExpand==0 && this.hasChild())
		{
			var ntabs=this.getNumOfTabsUnder();
			if(ntabs>0) this.ExtraStr='['+ntabs+Trans('tabshidden')+']';
			else		this.ExtraStr='';
		}
		else	this.ExtraStr='';
		return this.ExtraStr;
	}
	this.v_closeAction=function(){this.closeTab();}
	this.v_onSetHover=function(){if(this.URL!=null) this.setHover();}

	this.v_isGroup=function() { return (this.URL==null); }
	this.v_getNodeData=function(data,bOnlyChecked)
	{
		data.push(escape(this.Title));
		if(this.URL && (!bOnlyChecked||this.bChecked))data.push(escape(getActualURL(this.URL)));
		else	data.push('');
		data.push(this.bExpand.toString());
		return data;
	}
	this.v_getNodeDataStr=function(level,bOnlyChecked,oStr){alert('impossible');}
	this.v_getNodeIcon=function()
	{
		var fname;
		if(this.URL==null) fname='group.gif'; 
		else//tab
		{
			if(this.autoRefreshPeriod>0) fname='tab_autorefresh.gif';
			else
			{
				if(this.bAutoReferrer==1) 	fname='arefer_';
				else				fname='tab_';
				if(!(this.bReady)) 	fname+='loading_';
				if(this.Tree.bUseFilter) fname+='mask';
				else
				{
					if(this.bUnread)		fname+='unread';
					else				fname+='read';
				}
				fname+='.gif';
			}
		}
		return g_iconSize+'/'+fname;
	}
	this.v_getStyleClassName=function()
	{	
		if(this.bSelected==1)
		{
			if(this.URL!=null) 	return 'StyleTabSelect';
			else			return 'StyleGroupSelect';
		}
		if(this.URL!=null && this.isActive) return 'StyleTabActive';
		if(this.bExpand==0 && this.hasChild()) 	return 'StyleGroupFolded';
		if(this.URL!=null)
		{
			if(this.bUnread==0) 	return 'StyleTabNormal';
			else			return 'StyleTabUnread';
		}
		else
		{ 	
			if(this.bExpand==1) 	return 'StyleGroupOpened';	
			else			return 'StyleGroupFolded';	
		}
	}
	this.v_importNode=function(data,bRestoreState)
	{
		var newnode;
		var title=unescape(data[1]);
		var url=unescape(data[2]);
		var states=data[3];
		if(url=='') newnode=this.addChildGroup(title);
		else
		{
			var oTab=openURLinNewTab(url,false);
			if(oTab==null){alert('failed to create new tab for '+url);return null;}
			newnode=this.Tree.findNodeByTab(oTab);
			if(newnode==null) newnode=this.addChildTabNode(oTab);
			else{alert('error: imported into an existing tab');return null;}
		}
		if(bRestoreState) newnode.bExpand=(states.charAt(0)=='1')?1:0;
		return newnode;
	}
//------------- non-virtual functions -----------
	this.addChildTabNode=function(curtab,domain)
	{
		var tempnode=new CTabNode(null,this.Tree);
		curtab.UID=tempnode.UID;
		tempnode.oTab=curtab;
		tempnode.updateNodeData(curtab,true,true,domain);
		this.Tree.nTabsInTree++;
		return this.addChildNode(tempnode);
	}
	this.addChildDomainGroup=function(title,idx)
	{
		var node=this.addChildGroup(title,idx);
		node.bDomainGroup=true;
		node.Domain=title;
		return node;
	}
	this.onSort=function(type)
	{
		if(this.Child==null)return;
		this.Child.sort(eval('sortFunc'+type));
		this.Tree.refreshTree(true);
	}
	this.isBrokenLink=function()
	{
		var url=this.URL;
		if(url==null)return false;
		url=url.toLowerCase();
		if(url.indexOf('#http://',0)>=0) 	return true;
		else		return false;
	}
	this.mark=function(scope, bTabOnly)
	{
		var actstr='this.bMarked=true;';
		var constr=(bTabOnly)?' && this.URL!=null':'';
		if(scope=='_tab') this.bMarked=true;
		else if(scope=='_group' || scope=='_children')
		{
			this.visitAllA('true'+constr,actstr);
			if(scope=='_children')this.bMarked=false;
		}
		else if(scope=='_read') this.visitAllA('this.bUnread==0'+constr,actstr);
		else if(scope=='_above' || scope=='_below')
		{
			var pNode=this.Parent;if(pNode==null)return null;
			var idx=this.getRelativeIndex();
			var si=(scope=='_above')?0:idx;
			var ei=(scope=='_above')?idx:(pNode.Child.length-1);
			var i;
			for(i=si;i<=ei;i++)
			{
				pNode.Child[i].mark('_group',true);
			}
		}
		else if(scope=='_broken')this.visitAllA('this.isBrokenLink()',actstr);
		else {alert(scope);return null;}
		if((scope=='_above' || scope=='_below') && this.Parent!=null)return this.Parent;
		else	return this;
	}
	this.clearAutoRefresh=function()
	{
		if(this.autoRefreshTimerID!=null) window.clearTimeout(this.autoRefreshTimerID);
		this.autoRefreshPeriod=-1;
		this.autoRefreshTimerID=null;
	}
	this.startAutoRefresh=function(period)
	{
		if(this.autoRefreshTimerID!=null) window.clearTimeout(this.autoRefreshTimerID);
		this.autoRefreshPeriod=period;
		this.redrawNode();
		this.autoRefreshTimerID=window.setTimeout(this.Tree.refName+'.funcTimerRefreshPage('+this.UID+')',this.autoRefreshPeriod);
	}
	this.getNumOfTabsUnder=function()
	{
		var n=0;
		for(var i=0;i<this.Child.length;i++)
		{
			if(this.Child[i].hasChild()) n+=this.Child[i].getNumOfTabsUnder();
			if(this.Child[i].URL!=null) n++;
		}
		return n;
	}
	this.handleSpecialSites=function(curdoc)
	{
		if(this.Tree.bAutoRename==0 || curdoc.body==null) return null;
		var i,tstr,len;
		for(i=0;i<g_listAutoRename.length;i++)
		{
			if(curdoc.URL.substr(0,g_listAutoRename[i][0].length)==g_listAutoRename[i][0])
			{
				tstr=curdoc.title;
				len=g_listAutoRename[i][2].length;
				if(tstr.substr(0,len)==g_listAutoRename[i][2])
					return g_listAutoRename[i][3]+tstr.substr(len);
				return null;
			}
		}
		return null;
	}
	this.updateNodeData=function(curtab,bForce,bRefreshed,domain)
	{
		var bNodeChanged=false;
		var curdoc;
		try{
		if(('document' in curtab) && curtab.document!=null) curdoc=curtab.document;
		else curdoc=null;
		}
		catch(e){curdoc=null;}
		var title,lastModified, readyState, url;

		if(curdoc==null){
			title=Trans('loading');url=Trans('unknown');
			lastModified=Trans('unknown');readyState=Trans('unknown');
		}
		else
		{
			if(('title' in curdoc) && curdoc.title!=null)
			{
				if(!bForce && this.oldTitle==curdoc.title)title=this.Title;
				else
				{
					var temp=this.handleSpecialSites(curdoc);
					if(temp!=null)
					{
						title=temp;
						if(this.Tree.bProtectTab==0) curdoc.title=title;
					}
					else{
						if(curdoc.title.length==0)
						{
							title=curdoc.URL;
							if(title.toLowerCase().indexOf('file://')==0) title=title.substr(7);
						}
						else title=curdoc.title;
					}
				}
			}
			else title=Trans('loading');
			this.oldTitle=curdoc.title;	
			if(('URL' in curdoc) && curdoc.URL!=null)
			{
				url=curdoc.URL;
				if(url!=this.URL)
				{
					if(this.URL!=null)g_dictURL.Remove(this.URL);
					g_dictURL.Add(url,this);
				}
			}
			else url=Trans('unknown');
			if(('lastModified' in curdoc) && curdoc.lastModified!=null) lastModified=curdoc.lastModified;
			else lastModified=Trans('unknown');
			if(('readyState' in curdoc) && curdoc.readyState!=null) readyState=curdoc.readyState;
			else readyState=Trans('unknown');
		}
		if(title!=this.Title) {
			this.Title=title;
			if(curdoc!=null && title in curdoc)
			{
				curdoc.title=title;
				this.oldTitle=title;
			}
			bNodeChanged=true; 
		}
		if(url!=this.URL) { this.URL=url;bNodeChanged=true; }
		if(lastModified!=this.lastModified) { this.lastModified=lastModified;}
		if(readyState!=this.readyState) {this.readyState=readyState;bNodeChanged=true; }
		if(readyState=='complete') this.bReady=true;
		if(bRefreshed && this.bUnread==0) {this.bUnread=1;bNodeChanged=true;}
		if(domain)this.Domain=domain;
		return bNodeChanged;
	}
	this.markUnread=function(bUnread)
	{
		this.bUnread=bUnread;
		if(this.URL==null) return;
		this.redrawIcon();
		this.redrawStyle();
	}
	this.setActive=function()
	{
		this.markUnread(0);
		var sTXA='TXA'+this.UID;
		if(this.isActive)return;
		try{this.Tree.lastActiveNode.isActive=false; this.Tree.lastActiveNode.redrawStyle();}catch(e){}
		this.isActive=true;
		try{
			this.setSpecialStyle("StyleTabActive");
			this.Tree.lastActiveNode=this; 
		}catch(e){}
		var tnode=this.Parent;
		while(tnode!=null)//expand all its ancestors
		{
			if(tnode.hasChild() && tnode.bExpand==0)
			{
				tnode.bExpand=1; tnode.redrawNode();tnode.redrawStyle();
			}
			tnode=tnode.Parent;
		}
	}
	this.getTabID=function()
	{//cachedTabID to improve performance
		if(this.URL==null)return -1;
		if(this.cachedTabID!=null &&this.oTab!=null && this.oTab==A_get_tab(this.cachedTabID)) return this.cachedTabID;
		var curtab,i, n=external.tab_count;
		for (i=0;i<n;i++) if((curtab=A_get_tab(i))!=null && curtab==this.oTab)
			{this.cachedTabID=i;return i;}
		return -1;
	}
	this.closeTab=function()
	{
		if(this.Parent==null || this.URL==null) return;
		var tid=this.getTabID();
		if(tid<0){alert("closeTab(): no matching uid("+this.Title+")");return;}
		A_close_tab(tid);
		var tnode=this.getNextSibTabNode(false,1);//activate next sibling node
		if(tnode==null)
		{
			tnode=this.getNextSibTabNode(false,-1);
			if(tnode==null) tnode=this.Parent;
		}
		if(tnode!=null && tnode.URL) this.Tree.nextActiveNode=tnode;
	}	
	this.getNextSibTabNode=function(bLoop, dir)
	{
		if(this.Parent==null) return null;//root and non-tab node
		var onode=this;
		var idx=onode.getRelativeIndex();
		if(idx<0)return null;
		var pnode=onode.Parent;
		var len=pnode.Child.length;
		var i=idx+dir;
		var n=0;
		do{
			if(i<0) { if(!bLoop)return null; i=len-1;}
			else if(i>=len) { if(!bLoop)return null;i=0;}
			onode=pnode.Child[i];
			if(onode.URL!=null) return onode;
			i+=dir;	
			n++;
			if(n>=len)break;
		}while(true);
		return null;
	}
	this.onGetNextChildTabNode=function(dir)
	{
		if(!this.hasChild())return null;
		var to=this.Tree.lastActiveNode;
		if(to==null || to.Parent!=this)
		{
			if(dir>0) 	to=this.Child[this.Child.length-1];
			else		to=this.Child[0];	
		}
		if(to==null)return null;
		return to.getNextSibTabNode(true,dir);
	}
	this.onToggleRead=function(scope)
	{
		var node=this.mark(scope,true)
		var bUnread;
		if(scope=='_tab')bUnread=(1-this.bUnread);
		else
		{
			var cnt=new Array();
			cnt.nRead=0;
			cnt.nUnread=0;
			node.visitAll("(this.bMarked && this.URL!=null)",
				"shareddata.nRead+=(1-this.bUnread);shareddata.nUnread+=this.bUnread;",cnt,false);
			if(cnt.nRead+cnt.nUnread==0) return;
			if(cnt.nRead>cnt.nUnread)bUnread=1;
			else			 bUnread=0;
		}
		node.visitAllA('this.bMarked','this.bMarked=false;this.markUnread('+bUnread+')');
	}
	this.doCopyToClipboard=function()
	{
		var url;
		if(this.URL==null) url=this.Title;
		else			url=getActualURL(this.URL);
		window.clipboardData.setData("Text",url);
	}
	this.onCopyToClipboard=function(scope)
	{
		var node=this.mark(scope,true)
		var urllist=new Array();
		urllist.allurl='';
		node.visitAll('this.bMarked',"this.bMarked=false;shareddata.allurl+=getActualURL(this.URL)+'\\r\\n'",urllist,false);
		window.clipboardData.setData("Text",urllist.allurl);
	}
	this.dorefreshpage=function()
	{
		var tid=this.getTabID();
		if(tid<0)return;
		A_get_tab(tid).document.execCommand('refresh');//this line is from Levent Da' plug-in "Tabigator"
	} 
	this.dosavepage=function()
	{
		A_m2_run_cmd(32780);//toggle work offline
		var tid=this.getTabID();
		if(tid<0)return;
		var title;
		if(this.Title==null) title=this.URL;
		else			title=this.Title;
		A_get_tab(tid).document.execCommand('saveas',true,title);
		A_m2_run_cmd(32780);//toggle work offline
		return;
	}
	this.doaddtofavorite=function()
	{
		var title, url;
		title=this.Title;url=this.URL;
		if(this.URL==null)	url='http://'+this.Title;
		external.addFavorite(url,title);
	}
	this.doaddtoblocklist=function()
	{
		if(this.URL==null) return;
		external.addFilter(this.URL);
	}
	this.onBatchCommand=function(cmdstr,scope)
	{//cmdstr=refreshpage, savepage, addtofavorite, addtoclipboard
		var node=this.mark(scope,true);
		node.visitAllA('this.bMarked','this.bMarked=false;this.do'+cmdstr+'();');
	}
	this.onAddAutoRename=function()
	{
		var tid=this.getTabID();
		var atitle;
		try{atitle=A_get_tab(tid).document.title;}catch(e){atitle=null;}
		if(atitle==null)return;
		openDlgAddAutorename(this.URL, atitle);
	}
	this.onRename=function()
	{
		var pretitle=this.Title;
		if(pretitle==null || pretitle.length==0) pretitle="newtitle";
		var theResponse = prompt(Trans("promptrename"),pretitle);
		if(theResponse==null)return;
		this.Title=theResponse;
		var tabid=this.getTabID();
		if(tabid>=0)
		{
			var tabb=A_get_tab(tabid);
			if(tabb!=null) tabb.document.title=this.Title;
			this.oldTitle=this.Title;
		}
		this.Tree.bTreeChanged=true;
		this.Tree.refreshTree(true);
	}
	this.onNewGroup=function()
	{
		var theResponse = prompt(Trans("promptnewgroup"),"newgroup");
		if(theResponse==null)return;
		var newnode=this.addChildGroup(theResponse);
		this.Tree.refreshTree();
	}
	this.onExportTree=function()
	{
		g_dialogs.openDialog('',{"main":g_mainWin,"onload":"onLoadDlgFavTree","underNode":this, "bSelectOnly":1},g_popClickX,g_popClickY,500,400);
	}
	this.onImportTree=function()
	{
		g_dialogs.openDialog('',{"main":g_mainWin,"onload":"onLoadDlgFavTree","underNode":this, "bSelectOnly":0},g_popClickX,g_popClickY,500,400);
	}
	this.onAutoRefreshPage=function()
	{
		if(this.autoRefreshPeriod>0) this.clearAutoRefresh();
		else
		{
			var sPeriod = prompt(Trans('msgautorefreshperiod'),'60');
			if(sPeriod==null || sPeriod=='')return;
			var iPeriod=parseInt(sPeriod);
			if(iPeriod<=0) return;
			this.startAutoRefresh(iPeriod*1000);
		}
		this.redrawNode();
	}
	this.isLocalFile=function()
	{
		var url=this.URL;
		var filestr='file://';
		url=url.toLowerCase();
		var idx=url.indexOf(filestr);
		if (idx>=0) return true;
		else return false;
	}
	this.onToggleAutoReferrer=function(urlExclude)
	{	
		this.setAutoReferrer(1-this.bAutoReferrer);
	}
	this.setAutoReferrer=function(bSet,urlExclude)
	{	
		var tabid=this.getTabID();
		if(tabid>=0)
		{
		  var curtab=A_get_tab(tabid);
		  if(curtab!=null)
		  {
			var x=curtab.document.links;
			this.bAutoReferrer=bSet;	
			if(this.bAutoReferrer==1)
			{
				curtab.bAutoReferrer='1';
				if(this.isLocalFile() && urlExclude==null){alert(Trans('localfileerr'));return;}
				for(var i=0; i<=x.length-1; i++)try
				{
					if(!('oldtarget' in x[i]))
					{
						if('target' in x[i])x[i].oldtarget=x[i].target;
						else			x[i].oldtarget='_self';
					}
					if(urlExclude && urlExclude==x[i].href.substr(0,urlExclude.length)) {}
					else x[i].target='_blank';
				}catch(e){}
			}
			else
			{
				if('bAutoReferrer' in curtab && curtab.bAutoReferrer=='1')
				{	
					for(var i=0; i<=x.length-1; i++)try
					{ if('oldtarget' in x[i])x[i].target=x[i].oldtarget;}catch(e){}
				}
				curtab.bAutoReferrer='0';
			}
		  }
		}
		this.redrawNode();
	}
}//end of CTabNode

function ___CFavNode_______(){}
function CFavNode(title,tree)
{
	this.base=CTreeNode;
	this.base(title,tree);

//---------------"virtual" functions------------
//	this.v_isHidden=function(){return false;}
//	this.v_isDroppable=function(pos){return true;}
//	this.v_isDraggable=function(){return (this.Parent!=null);}
//	this.v_getFilterStr=function(){return '';}
//	this.v_getNodeText=function() { return this.Title; }
//	this.v_getToolTip=function(){return '';}
//	this.v_getExtraStr=function() {return '';}
//	this.v_closeAction=function(){}
//	this.v_onSetHover=function() {this.setHover();}

	this.v_isGroup=function(){return (this.URL==null);}
	this.v_getNodeData=function(data,bOnlyChecked)
	{
		data.push(escape(this.Title));
		if(this.URL && (!bOnlyChecked||this.bChecked))data.push(escape(getActualURL(this.URL)));
		else	data.push('');
		data.push(this.bExpand.toString());
		return data;
	}
	this.v_getNodeDataStr=function(level,bOnlyChecked,oStr)
	{
		oStr.Append(level);
		oStr.Append('|');
		oStr.Append((escape(this.Title)));
		oStr.Append('|');
		if(this.URL && (!bOnlyChecked||this.bChecked)) oStr.Append(escape(getActualURL(this.URL)));
		oStr.Append('|');
		oStr.Append(this.bExpand);
		oStr.Append('|\r\n');
		return true;
	}
	this.v_getNodeIcon=function()
	{
		var fname,sopen;
		if(this.URL==null||this.URL=='')
		{
			fname=(this.bExpand)?'folder_open.gif':'folder_close.gif';
		}
		else
		{
			fname='page_white.gif';
		}
		return g_iconSize+'/'+fname;
	}
	this.v_getStyleClassName=function()
	{
		if(this.bSelected==1)
		{
			if(this.URL!=null) 	return 'StyleTabSelect';
			else			return 'StyleGroupSelect';
		}
		if(this.bExpand==0 && this.hasChild()) 	return 'StyleGroupFolded';
		else if(this.URL!=null) 		return 'StyleTabUnread';
		else					return 'StyleGroupOpened';	
	}
	this.v_importNode=function(data,bRestoreState)
	{
		var newnode;
		var title=unescape(data[1]);
		var url=unescape(data[2]);
		var states=data[3];
		if(url=='') newnode=this.addChildGroup(title);
		else	newnode=this.addChildFavNode(title,url);
		if(bRestoreState) newnode.bExpand=(states.charAt(0)=='1')?1:0;
		return newnode;
	}
//------------- non-virtual functions -----------
	this.addChildFavNode=function(title,url)
	{
		var tempnode=new CFavNode(title,this.Tree);
		tempnode.URL=url;
		return this.addChildNode(tempnode);
	}
	this.onRename=function()
	{
		var pretitle=this.Title;
		if(pretitle==null || pretitle.length==0) pretitle="newtitle";
		var theResponse = prompt(Trans("promptrename"),pretitle);
		if(theResponse==null)return;
		this.Title=theResponse;
		this.Tree.refreshTree(true);
	}
}//end of CFavNode
/* ------------------------------Tree Classes --------------------*/
var g_DictDomain=new ActiveXObject("Scripting.Dictionary");//maintained by CTabNode
var g_dictURL = new CDictReferrer();

function ___CTabTree_____(){}
function getActualDomain(curdomain,url)
{
	if(!(curdomain==null||curdomain.length==0))return curdomain; 
	var cstr='#http://';
	var filestr='file://';
	var tstr='untitled';
	var idx;
//	url=url.toLowerCase();
	idx=url.indexOf(cstr,0);
	if(idx>=0) 
	{
		idx+=cstr.length;
		var idx2=url.indexOf('/',idx);
		if(idx2<0) return tstr;
		tstr= url.substr(idx,idx2-idx);
	}
	else
	{
		idx=url.indexOf(filestr);
		if(idx>=0) tstr='localfile';
	}
	return tstr;
}
function refreshDebugWin()
{
	if(!g_bShowDebugWin)return;
	if(!g_bDlgTabtreeReady)return;
	if('oDebugWin' in g_TabTree.Dlg)
	{
		while(g_deferedMsgs.length>0)
		{
			g_sMsgBuf='['+g_idMsg+']'+g_deferedMsgs[0]+'\n'+g_sMsgBuf;
			g_idMsg++;
			g_nMsgs++;
			if(g_nMsgs>50)
			{
				var idx=g_sMsgBuf.lastIndexOf('\n',g_sMsgBuf.length-2);	
				if(idx>0){ g_sMsgBuf=g_sMsgBuf.substr(0,idx+1);g_nMsgs--;}
			}
			g_deferedMsgs.splice(0,1);
		}
		g_TabTree.Dlg.oDebugWin.innerText=g_sMsgBuf;
	}
}
function CTabTree(roottitle,refName)
{
	this.v_newNode=function(title){return (new CTabNode(title,this));}
	this.base=CTree;
	this.URL = null;
	this.base(roottitle,refName);
	this.bShowRoot=1; //determine if the root node displayed or not
	this.bShowLine=1;
	this.Dlg=null;
	this.nTabsInTree=0;

	this.TimerID=null;
	this.tSyncPeriod=2000;
	this.bAutoSync=1;
	this.tabunderlineID=null;
	this.bShortDomain=0;
	this.bAutoRename=0;
	this.bAutoHide=0;
	this.bShowCaption=0;
	this.bTabTooltip=1;
	this.bShowSingleTabDomain=1;
	this.bProtectTab=1;
	this.bCheckTree=0;
	this.bSelectOnly=0;
	this.lastActiveOffsetLeft=0;
	this.lastActiveOffsetTop=0;
	this.adjustedActiveNode=null;
	this.bBig=1;
	this.bUseFilter=true;
	this.bClearEmptyFolders=true;
	this.nextActiveNode=null;
	this.v_isDisabled=function()
	{
		return (g_dialogs.isAnyOpen() || !g_bDlgTabtreeReady || g_popMenus.isAnyOpen());
	}
	this.v_onMouseOut=function()
	{
		if(this.Dlg==window)return;
		//start a delayed function to detect possible moving out of window 
		this.mouseOutTimerID=setTimeout(this.refName+'.onMouseOutDelayed()',30);
	}
	this.v_onMouseOver=function()
	{
		if(this.v_isDisabled())return;
		if(this.Dlg==window)
		{
			window.focus();
//			window.document.click();
//			this.getObj('TREEDIV').focus();
			return;
		}
		if(this.mouseOutTimerID)
		{
			clearTimeout(this.mouseOutTimerID);
			this.mouseOutTimerID=null;
		}
		try{
			if(!g_isFocus)
			{
			//	this.getObj('TREEDIV').focus();
				this.Dlg.focus();
				g_isFocus=true;
			}
			g_isFocus=true;
			if(this.bAutoHide && this.bBig==0)
			{
				this.bBig=1;
				if(this.Dlg!=null)
				{
					var dim=new Array();
					getDlgDims(this.Dlg,dim)
					if(this.Dlg.g_lastW>0 && this.Dlg.g_lastH>0)
					{
						dim.w=this.Dlg.g_lastW;
						dim.h=this.Dlg.g_lastH;
					}
					else
					{
						dim.w=100;
						dim.h=400;
					}	
					this.Dlg.close();
					openDlgTabtree(dim);
				}
			}
		}catch(e){}
	}
	this.v_onGesture=function(tnode,gstr,lastButton)
	{
		if(lastButton!=1)return;
		if(gstr=='43' || gstr=='34')
		{
		    if(tnode.URL==null && tnode.hasChild())tnode.onBatchCommand('refreshpage','_group');
		    else if(tnode.URL!=null)tnode.onBatchCommand('refreshpage','_tab');
		}
		else if (gstr=='4' && tnode.URL!=null)
		{
		    this.onClick('TXA',tnode.UID,1);
		    A_get_tab(external.cur_sel).scrollTo(0,10000000);
		}
		else if (gstr=='3' && tnode.URL!=null)
		{
		    this.onClick('TXA',tnode.UID,1);
		    A_get_tab(external.cur_sel).scrollTo(0,0);
		}
	}
	this.v_onDblClick=function(node,type,lastButton)
	{
		if(lastButton!=1) return;
		if(node.URL!=null || !node.hasChild()) this.onClose(node,'_tab');
		else this.onClose(node,'_group');
	}
	this.v_onClick=function(node,type,lastButton)
	{
		if(lastButton==1)//left click
		{
			if(node.URL!=null && type!='CON')
			{
				A_activate_tab(node.getTabID());
				node.setActive();
				this.Dlg.focus();
			}
		}
	}
	this.v_onMouseWheel=function(node,type,delta)
	{
		if(node.URL!=null && isTextType(type))
		{
			this.onClick(type,node.UID,1);
			A_get_tab(external.cur_sel).scrollBy(0,delta*90);
			return false;
		}
		var slowdown=2;
		if(g_mouse.wheelDir>=slowdown || g_mouse.wheelDir<=-slowdown)
		{
			if(g_mouse.wheelDir>=slowdown)delta=-1;
			else if(g_mouse.wheelDir<=-slowdown)delta=1;	
			else	{g_mouse.wheelDir=0;return false;}
			g_mouse.wheelDir=0;
		}
		else return false;
		if(node.hasChild())
		{
			var to=node.onGetNextChildTabNode(-delta);if(to==null)return false;
			A_activate_tab(to.getTabID());
			to.setActive();
		}
		this.Dlg.focus();
		return false;
	}
	this.v_getUpdatedContextMenu=function(type,node)
	{
		var oMenu;
		if(node==null)
		{
			var bFloat;
			if(window==this.Dlg)	bFloat=false;
			else		bFloat=true;
			this.getContextMenu('global').checkItem('autogroupbydomain',(this.bAutoGroupByDomain==1));
			this.getContextMenu('global').checkItem('autorename',(this.bAutoRename==1));
			this.getContextMenu('global').checkItem('autohide',(this.bAutoHide==1));
			this.getContextMenu('global').enableItem('float',!bFloat);
			this.getContextMenu('global').enableItem('autohide',bFloat);
			this.getContextMenu('global').enableItem('showsingletabdomain',(this.bAutoGroupByDomain==1));
			this.getContextMenu('global').enableItem('protecttab',(this.bAutoRename==1));
			oMenu=this.getContextMenu('global');
		}
		else
		{
			//set enable and check states
			var mi,smi;
			var bTab      =(node.URL!=null)?true:false;
			var bGroup=node.hasChild();
			var bChildren = (bGroup && node.URL!=null);
			var idx=node.getRelativeIndex();
			var bAbove=(idx>0)?true:false;	
			var bBelow=(idx>=0 && node.Parent!=null && idx<node.Parent.Child.length-1)?true:false;	
		//	alert(idx+' '+(node.Child.length-1));
			var bRead=bGroup;
			var bBroken=true;
			var i,j,n;
			var ArrayNCM;
			if(node.URL!=null)
			{
				if(node.hasChild())
				{
					ArrayNCM=g_listContextMenus['referrer'];
					oMenu=this.getContextMenu('referrer');
				}
				else
				{
					ArrayNCM=g_listContextMenus['tab'];
					oMenu=this.getContextMenu('tab');
				}
			}
			else
			{
				ArrayNCM=g_listContextMenus['group'];
				oMenu=this.getContextMenu('group');
			}
			node.setSelect();
			for(i=0;i<ArrayNCM.length;i++)
			{
				if(ArrayNCM[i].length<=1)continue;
				mi=oMenu.getItemByID(ArrayNCM[i][0]);
				if(mi!=null && mi.subMenu!=null)
				{
					if(bGroup||bChildren||bRead||bAbove||bBelow)
					{
						n=mi.subMenu.items.length;
						for(j=0;j<n;j++)
						{
							smi=mi.subMenu.items[j]		
							switch(smi.sName)
							{
							case '_tab': mi.subMenu.enableItem(smi.sName,bTab);break;
							case '_children': mi.subMenu.enableItem(smi.sName,bChildren);break;
							case '_group': mi.subMenu.enableItem(smi.sName,bGroup);break;
							case '_above': mi.subMenu.enableItem(smi.sName,bAbove);break;
							case '_below': mi.subMenu.enableItem(smi.sName,bBelow);break;
							case '_read': mi.subMenu.enableItem(smi.sName,bRead);break;
							case '_broken': mi.subMenu.enableItem(smi.sName,bBroken);break;
							}
						}
						mi.bHideSubMenu=false;
					}
					else	mi.bHideSubMenu=true;
				}
			}
		}
		return oMenu;
	}
	this.v_preRemoveNode=function(node)//only remove leaf node
	{
		var pnode=node.Parent;
		if(pnode==null) return false;//do not remove root node
		if(node.URL!=null && g_dictURL.Exists(node.URL)) 
		{
			g_dictURL.Remove(node.URL,node.UID);
			this.nTabsInTree--;
		}
		this.bTreeChanged=true;
		node.clearAutoRefresh();
		if(g_DictDomain.Exists(node.Domain) && g_DictDomain.Item(node.Domain)==node) g_DictDomain.Remove(node.Domain);
		node.bDomainGroup=false;
		if(node.hasChild())
		{
			node.URL=null;
			node.redrawNode();
			node.redrawStyle();
			return false;
		}	
		else return true;
	}
	this.v_postRemoveNodesUnder=function(pNode)
	{
		this.clearSingleTabDomain();
	}
	this.v_needRefresh=function(bChanged, bForce)
	{
		if(bForce!=1 && !g_bDlgTabtreeReady) return false;
		if(bChanged!=null) this.bTreeChanged=bChanged;
		this.synchronizeTreeData(this.bTreeChanged);
		if(!this.bTreeChanged)
		{
			this.findSetActiveTab(false);
			return false;
		}
		return true;
	}
	this.v_postRefreshTree=function()
	{	
		this.bAutoSync=1-this.bAutoSync;onToggleTimer();//Draw TimerIcon
		this.findSetActiveTab(true);
		if(this.bShowCaption) 	this.Dlg.maincaptionTR.style.display = "block";
		else 				this.Dlg.maincaptionTR.style.display = "none";
	}//end of function refreshTree()
	this.v_postMoveNode=function(sNode,dNode,pos)
	{
		if(sNode.bDomainGroup && sNode.Parent!=this.TreeRoot)
		{
			if(g_DictDomain.Exists(sNode.Domain) && g_DictDomain.Item(sNode.Domain)==sNode) g_DictDomain.Remove(sNode.Domain);
			sNode.bDomainGroup=false;	
			sNode.redrawNode();
			sNode.redrawStyle();
		}
	}
	this.killMyTimer=function()
	{
		if(this.TimerID!=null){window.clearInterval(this.TimerID);this.TimerID=null;}
	}
	this.setMyTimer=function()
	{
		this.killMyTimer();
		this.TimerID=window.setInterval(this.refName+".onTimer();", this.tSyncPeriod);
	}
	this.onClose=function(node,scope)
	{	
		if(scope=='_group')
		{
			var title=(node.Parent==null)?Trans('rootnode'):node.Title;
			if(!confirm(Trans("confirmclose0")+title+Trans("confirmclose1")))
				return;
		}
		node=node.mark(scope,true);
		var curnode=getNodeForCurTab();
		var bClosed=curnode.bMarked;
		this.removeNodesUnder(node,'oNode.bMarked',true);
		this.refreshTree();
		if(bClosed)
		{
			try{A_activate_tab(this.nextActiveNode.getTabID())}catch(e){}
		}
	}
	this.clearSingleTabDomain=function()
	{
		if(this.bAutoGroupByDomain==0 || this.bShowSingleTabDomain==1)return;
		var node,node0,i,n=this.TreeRoot.Child.length;
		var domain;
		for(i=0;i<n;i++)
		{
			node=this.TreeRoot.Child[i];
			if(node.Child.length==1 && node.bDomainGroup && node.Child[0].URL!=null)
			{
				domain=node.Domain;
				if(g_DictDomain.Exists(node.Domain) && g_DictDomain.Item(node.Domain)==node) g_DictDomain.Remove(node.Domain);
				node0=node.Child[0];
				node0.Parent=node.Parent;
				g_DictNodeByUID.Remove(node.UID);
				delete node;
				this.TreeRoot.Child[i]=node0;
				if(!(g_DictDomain.Exists(domain)))g_DictDomain.Add(domain,node0);
			}
		}
	}
	this.onNewTab=function(curtab)
	{	
		var curdoc,curdomain,curURL,curtitle,curreferrer,curreadyState;
		var bReady;
		try { curdoc=curtab.document;} catch(e){curdoc=null;}
		try { curdomain=curdoc.domain;} catch(e){curdomain=null;}
		try { curURL=curdoc.URL;} catch(e){curURL=null;}
		try { curtitle=curdoc.title;} catch(e){curtitle=null;}
		try { curreferrer=curdoc.referrer;} catch(e){curreferrer=null;}
		try { curreadyState=curdoc.readyState;} catch(e){curreadyState=null;}
		try { curlastModified=curdoc.lastModified;} catch(e){curlastModified=null;}
		bReady=(curdoc!=null&&curURL!=null&&curtitle!=null&&curreferrer!=null&&curreadyState!=null&&curlastModified!=null);
		var tnode;
		if(bReady)//new tab and doc is ready
		{
//			curdomain='test';
			curdomain=getActualDomain(curdomain,curURL);
			if(g_dictURL.Exists(curreferrer))
			{
				tnode=g_dictURL.Item(curreferrer);
				if(tnode)tnode.addChildTabNode(curtab,curdomain);
			}
			else if(this.bAutoGroupByDomain==0) this.TreeRoot.addChildTabNode(curtab,curdomain);
			else
			{
				if(!(g_DictDomain.Exists(curdomain)))//domain key not found
				{
					if(this.bShowSingleTabDomain)
					{
						tnode=this.TreeRoot.addChildDomainGroup(curdomain);
						tnode.addChildTabNode(curtab,curdomain);
					}
					else tnode=this.TreeRoot.addChildTabNode(curtab,curdomain);
					g_DictDomain.Add(curdomain,tnode);
				}
				else//domain key found
				{
					var dnode=g_DictDomain.Item(curdomain);
					if(dnode.URL!=null)
					{
						g_DictDomain.Remove(curdomain);
						tnode=this.TreeRoot.addChildDomainGroup(curdomain,dnode.getRelativeIndex());
						g_DictDomain.Add(curdomain,tnode);
						this.moveNode(dnode,tnode,0);
						tnode.addChildTabNode(curtab,curdomain);
					}
					else
					{
						dnode.addChildTabNode(curtab,curdomain);
					}
				}
			}
		}
		else//new tab but doc not ready
		{//simply not display it
		}
		this.bTreeChanged=true;
	}
	this.synchronizeTreeData=function(bForce)
	{
		function _isBlankTab(curtab)
		{
			var curdomain=null;var cururl=null;var tt;
			try{
				cururl=curtab.document.URL;
				try{curdomain=curtab.document.domain;}catch(e){curdomain=null;}
				tt=getActualDomain(curdomain,cururl);
				if(tt=='untitled')return true;
			}catch(e){return false;}
		}
		//Implemenation of function synchronizeTreeData()
		var i,curtab;
		var nTabs=external.tab_count;
		//var 
//		timeStamp('sync0');	
		for (i=0;i< nTabs ;i++)
		{
			if((curtab=A_get_tab(i))==null) continue;	
			var tnode=null;
			var bRefreshed=false;
			if(('UID' in curtab) && (g_DictNodeByUID.Exists(curtab.UID)))//unrefreshed existing tab
			{
				tnode=g_DictNodeByUID.Item(curtab.UID);
				if(tnode.URL==null) tnode=null;
			}
			else//refreshed existing tab or new tab
			{
				tnode=this.findNodeByTab(curtab);	
				if(tnode!=null)//existing tab but was refreshed, therefore update UID
					curtab.UID=tnode.UID;
				bRefreshed=true;
			}
			if(tnode!=null && bRefreshed && (
					(tnode.Domain=='untitled') ||
					(tnode.Domain!='untitled' && _isBlankTab(curtab))  ))
			//blank->non-blank, or non-blank->blank
			{
				this.removeNodesUnder(tnode, null, false);
				tnode=null;//set to be null, to be processed by "new tab" module
			}
			if(tnode==null) this.onNewTab(curtab);//new tab (not found in tree)
			else//existing tab
			{
				tnode.bReady=false;
				if(tnode.updateNodeData(curtab,bForce,bRefreshed))
				{
					tnode.redrawNode();
					tnode.redrawStyle();
				}
			}
		}//end of for all tabs
//		timeStamp('sync1');
//		showTime('sync0','sync1');
		if(this.nTabsInTree>nTabs)//Clear closed tabs
		{
			this.removeNodesUnder(this.TreeRoot,'(oNode.URL!=null&&oNode.getTabID()<0)',false);
		}
//		timeStamp('sync2');
//		showTime('sync1','sync2');
	}//end of function synchronizeTreeData()
	this.findSetActiveTab=function(bBodyRefreshed)
	{
		var node=getNodeForCurTab();
		if(node!=null && node.URL!=null)
		{
			node.setActive();
			if(!bBodyRefreshed && this.adjustedActiveNode && this.adjustedActiveNode==node)return;
			var oDiv=this.getObj('TREEDIV');
			if(!oDiv){dumpMsg('error: div does not exist');return;}
			var oTBL=this.getObj('TBL'+node.UID);
			var tbl_t=oTBL.offsetTop;
			var tbl_b=tbl_t+oTBL.offsetHeight;
			var div_t=oDiv.scrollTop;
			var div_b=oDiv.clientHeight+div_t;
			if(tbl_t<div_t) oDiv.scrollTop-=div_t-tbl_t;
			else if(tbl_b>div_b)oDiv.scrollTop+=tbl_b-div_b; 
			this.adjustedActiveNode=node;
		}
	}
	this.onClickAutoRename=function(btnobj)
	{
		if(g_dialogs.isAnyOpen())return;
		this.bAutoRename=1-this.bAutoRename;
		try{btnobj.className=(this.bAutoRename==0)?"StyleImgButtonOFF":"StyleImgButtonON";}catch(e){}
		try{btnobj.savedClassName=btnobj.className;}catch(e){}
		this.refreshTree(true);
	}
	this.onClickAutoHide=function(btnobj)
	{
		if(g_dialogs.isAnyOpen())return;
		this.bAutoHide=1-this.bAutoHide;
		try{btnobj.className=(this.bAutoHide==0)?"StyleImgButtonOFF":"StyleImgButtonON";}catch(e){}
		try{btnobj.savedClassName=btnobj.className;}catch(e){}
	}
	this.onClickAutoGroupByDomain=function(btnobj)
	{
		if(g_dialogs.isAnyOpen())return;
		this.bAutoGroupByDomain=1-this.bAutoGroupByDomain;
		writeKey('autogroupbydomain',this.bAutoGroupByDomain.toString());
		try{btnobj.className=(this.bAutoGroupByDomain==0)?"StyleImgButtonOFF":"StyleImgButtonON";}catch(e){}
		try{btnobj.savedClassName=btnobj.className;}catch(e){}
		this.onToggleDomain();
	}
	this.generatePanelCaptionTR=function()
	{
		function IMGBTNSEP()
		{
			var str;
			str ='<TD style="width:6px;text-align:right;"><DIV style="width:1px;border-right:1px solid #333333"></DIV></TD>';
			str+='<TD style="width:6px;text-align:left;"><DIV style="width:1px;border-left:2px solid white"></DIV></td>';
			return str;
		}
		function IMGBTNSPACE() { return '<TD style="width:8px;text-align:right;"><div style="width:2px"></div></TD>'; }
		function IMGBTNTD(id,title,action,state)//state=0 or 1: bi-state button
		{
			var cname=(state!=null)?((state)?'StyleImgButtonON':'StyleImgButtonOFF'):'StyleImgButton';
			var str='<TD CLASS='+cname+' align=center ';
			str+=' title="'+Trans(title)+'" ID=IMGBTN'+id+' onclick="'+action+'" '; 
//			str+=' savedClassName="'+cname+'" ';	
			cname=(state!=null)?'StyleImgButtonONOFFover':'StyleImgButtonOutset';
			str+=' onmouseover="this.savedClassName=this.className;this.className=\''+cname+'\'"';
			str+=' onmouseout="this.className=this.savedClassName"';
			str+='><IMG ID=IMGBTNIMG'+id+' src="images/'+id+'.gif"></TD>';
			return str;
		}
		var str='';
		//str+='<TR ID=maincaptionTR style="display:block"><TD CLASS=StylePanelCaption ID=BBBBB background="images/caption.gif"><TABLE ID=maincaption width=100% cellspacing=0 cellpadding=0><TR>';
		str+='<TR ID=maincaptionTR style="display:block"><TD CLASS=StylePanelCaption ID=BBBBB><TABLE ID=maincaption width=100% cellspacing=0 cellpadding=0><TR>';
		str+=IMGBTNSPACE();
		str+=IMGBTNTD('config',	'mainmenu','g_mainWin.onMainMenu();return true;');
		str+=IMGBTNSPACE();
		str+=IMGBTNTD('favorite','favtree','g_mainWin.onFavorite(window);return true;');
		str+=IMGBTNSPACE();

		str+='<td style="width:100%"></td>';
		str+=IMGBTNTD('autorename','titleautorename','g_mainWin.'+this.refName+'.onClickAutoRename(this)',this.bAutoRename);
		str+=IMGBTNSPACE();
		str+=IMGBTNTD('groupdomain','titleautogroupbydomain','g_mainWin.'+this.refName+'.onClickAutoGroupByDomain(this)',this.bAutoGroupByDomain);
		if(window!=this.Dlg)
		{
			str+=IMGBTNSPACE();
			str+=IMGBTNTD('autohide','titleautohide','g_mainWin.'+this.refName+'.onClickAutoHide(this)',this.bAutoHide);
		}
		str+=IMGBTNSPACE();
		if(window!=this.Dlg) str+=IMGBTNTD('sidebar','titlesidebar','window.close()');
		else	str+=IMGBTNTD('float','titlefloat','g_mainWin.openDlgTabtree();');
		str+=IMGBTNSPACE();
		str+='</TR></TABLE></TD></TR>';
		//alert(str);
		return str;
	}
	this.generateBodyHTML=function()
	{
		//Implementation of generateBodyHTML()
		var str='<TABLE ID=TREETABLE CLASS=StylePanelTable cellspacing=0 cellpadding=0>';//<TR height=16px>';
		str+=this.generatePanelCaptionTR();
		str+='<TR><TD>';
		str+=this.getTreeDIVHTML();
		str+='</TD></TR>';
		if(g_bShowDebugWin)
		{
			str+='<TR style="height:122px;"><TD style="width:100%">';
			str+='<DIV ID="oDebugWin" style="width:100%;height:100%;white-space:nowrap;overflow:scroll;border:1px solid #cccccc;font-size:x-small;"></div>';

		}
		else{
			str+='<TR style="height:3ex;display:none"><TD style="width:100%">';
			str+='<DIV CLASS=StyleStatusDiv ID=oStatusDIV>&nbsp;</DIV>';
		}
		str+='</TD></TR></TABLE>';
		str+='<OBJECT id=dlgHelper2 CLASSID="clsid:3050f819-98b5-11cf-bb82-00aa00bdce0b" width="0px" height="0px"></OBJECT>';
		return str;
	}//end of  function generateBodyHTML()
	this.findNodeByTab=function(otab)
	{
		var oFindNode=new Array();
		oFindNode.oTab=otab;
		oFindNode.oNode=null;
		this.TreeRoot.visitAll("(this.URL!=null&&this.oTab==shareddata.oTab)",
					"shareddata.oNode=this",oFindNode,true);
		return oFindNode.oNode;
	}
	this.funcTimerRefreshPage=function(id)
	{
		var node=getNodeByUID(id);
		if(node==null || node.URL==null || node.autoRefreshPeriod<=0)return;
		node.onBatchCommand('refreshpage','_tab');
		node.startAutoRefresh(node.autoRefreshPeriod);
	}
	this.resetDomainInfor=function()
	{
		delete g_DictDomain;
		var n=this.TreeRoot.Child.length;
		for(var i=n-1;i>=0;i--)this.TreeRoot.Child[i].bDomainGroup=false;
		g_DictDomain=new ActiveXObject("Scripting.Dictionary");//maintained by CTabNode
	}
	this.clearDomains=function()
	{
		var node,node0,i,i0,n0,n=this.TreeRoot.Child.length;
		for(i=n-1;i>=0;i--)
		{
			node=this.TreeRoot.Child[i];
			if(node.URL==null)
			{
				n0=node.Child.length;
				for(i0=n0-1;i0>=0;i0--)
				{
					this.moveNode(node.Child[i0],node,1);
				}
				if(node.Child.length>0)alert('impossible in clearDomains()');
				this.removeNode(node);
			}
		}
		this.resetDomainInfor();
	}
	this.refreshDomains=function()
	{
		this.resetDomainInfor();
		this.TreeRoot.Child.sort(sortFunc_domainA);
		var node,tnode,n=this.TreeRoot.Child.length;
		var curdomain;
		for(i=n-1;i>=0;i--)
		{	
			node=this.TreeRoot.Child[i];
			curdomain=node.Domain;
			if(curdomain==null || curdomain=='')continue;

				if(!(g_DictDomain.Exists(curdomain)))//domain key not found
				{
					if(this.bShowSingleTabDomain)
					{
						tnode=this.TreeRoot.addChildDomainGroup(curdomain);
						this.moveNode(node,tnode,0);
					}
					else tnode=node;
					g_DictDomain.Add(curdomain,tnode);
				}
				else//domain key found
				{
					var dnode=g_DictDomain.Item(curdomain);
					if(dnode.URL!=null)
					{
						g_DictDomain.Remove(curdomain);
						tnode=this.TreeRoot.addChildDomainGroup(curdomain,dnode.getRelativeIndex());
						g_DictDomain.Add(curdomain,tnode);
						this.moveNode(dnode,tnode,0);
						this.moveNode(node,tnode,0);
					}
					else	this.moveNode(node,dnode,0);
				}
		}
	}
	this.onToggleDomain=function()
	{
		if(this.bAutoGroupByDomain==0) 	this.clearDomains();
		else				this.refreshDomains();
		this.refreshTree(true);
	}
	this.onToggleSingleTabDomain=function()
	{
		if(this.bAutoGroupByDomain==0){alert('impossible');return;}
		if(this.bShowSingleTabDomain==0) this.clearSingleTabDomain();
		else
		{
			var node,node0,i,n=this.TreeRoot.Child.length;
			for(i=n-1;i>=0;i--)
			{
				node=this.TreeRoot.Child[i];
				if(node.URL && node.Domain)//a tab
				{
					var newgroup=this.TreeRoot.addChildDomainGroup(node.Domain, node.getRelativeIndex());
					this.moveNode(node,newgroup,0);
				}
			}
		}
		this.refreshTree(true);
	}
	this.onResize=function()
	{
		saveDims(this.Dlg);
	}
	this.onTimer=function()
	{
		if(this.v_isDisabled())return;
		if(this.bAutoSync==1)
		{
			this.refreshTree(); 
			refreshDebugWin();
		}
	}
	this.mouseOutTimerID=null;
	this.bCheckingMouseOut=false;//to screen out onProperty change not issued by Tabtree
	this.onMouseOutDelayed=function()
	{
		if(this.mouseOutTimerID)
		{
			clearTimeout(this.mouseOutTimerID);
			this.mouseOutTimerID=null;
		}
		if(this.v_isDisabled())return;
		if(this.Dlg==null || this.Dlg==window)return;
		this.bCheckingMouseOut=true;
		this.Dlg.document.title='red';//to invoke onCheckMousePos Event
	}
	this.onCheckMousePos=function()
	{
		if(this.v_isDisabled())return true;
		if(this.Dlg==null || this.Dlg==window || !this.bCheckingMouseOut)return true;
		this.bCheckingMouseOut=false;
		try
		{
			var dim=new Array();
			getDlgDims(this.Dlg,dim);
			var x=this.Dlg.event.screenX;
			var y=this.Dlg.event.screenY;
			if(x>dim.x && y>dim.y && x<dim.x+dim.w && y<dim.y+dim.h) return;
			if(!(g_dialogs.isAnyOpen()))
			{
				try{ if(g_isFocus) A_get_tab(external.cur_sel).focus(); }catch(e){}
				g_isFocus=false;
			}
			if(this.bAutoHide && this.bBig==1)
			{
				this.bBig=0;
				if(this.Dlg!=null)
				{
					var dim2=new Array();
					getDlgDims(this.Dlg,dim2)
					dim2.w=-dim2.w;
					dim2.h=-dim2.h;
					this.Dlg.close();
					openDlgTabtree(dim2);
				}
			}
		}
		catch(e){}
	}
	this.redraw=function(dlg)
	{
		if(dlg)this.Dlg=dlg;
		else	dlg=this.Dlg;
		this.killMyTimer();
		applyIni();
		this.refreshTree(true,1);
		if(this.bShowCaption) 	dlg.maincaptionTR.style.display = "block";
		else 			dlg.maincaptionTR.style.display = "none";
		if(dlg!=window)
		{
			writeKey('insidebar','0');
			dlg.g_clientOffsetX=parseInt(dlg.screenLeft)-parseInt(dlg.dialogLeft);
			dlg.g_clientOffsetY=parseInt(dlg.screenTop)- parseInt(dlg.dialogTop);
		}
		else
		{
			writeKey('insidebar','1');
		}
		dlg.document.onselect= nullHandler;
		dlg.document.onselectstart= nullHandler;
		dlg.document.onclick=onClickElsewhere;

		dlg.document.onresize=  new Function("return "+this.refName+".onResize()");
		dlg.document.onpropertychange=new Function("return "+this.refName+".onCheckMousePos()");

		g_bDlgTabtreeReady=true;
		this.setMyTimer();
	}
	this.getContextMenu=function(cmname,bRebuild)
	{
		if(cmname in this.contextMenus && !bRebuild) 	return this.contextMenus[cmname];
		if(cmname in this.contextMenus) 		delete this.contextMenus[cmname];
		if(cmname!='global')
		{
			this.contextMenus[cmname]=this.createNodeContextMenu(g_listContextMenus[cmname]);
		}
		else	this.contextMenus[cmname]=this.createGlobalContextMenu();
		return this.contextMenus[cmname];
	}
	this.createNodeContextMenu=function(ArrayNCM)
	{
		var i,j,om,mi;
		var cm=new CMenu(this,this.refName+'.onClickNodeContextMenu');
		for(i=0;i<ArrayNCM.length;i++)
		{
			mi=cm.addNormalItem(null,ArrayNCM[i][0],'');
			if(ArrayNCM[i].length>1)
			{
				om=new CMenu(this,'');
				for(j=1;j<ArrayNCM[i].length;j++)
				{
					om.addNormalItem(null,ArrayNCM[i][j],'');
				}
				if(mi==null)alert('mi isnull');
				else mi.addSubMenu(om);
			}
		}
		cm.addHRItem('pophrcommon');
		for(i=0;i<g_listContextMenus['common'].length;i++) cm.addNormalItem(null,g_listContextMenus['common'][i],'');
		cm.addHRItem('pophrpluginsetup');
		cm.addNormalItem(null,'pluginsetup','');
		cm.build();
		return cm;
	}
	this.createGlobalContextMenu=function()
	{
		var cm=new CMenu(this,this.refName+'.onClickSetupMenu');
		var mi;
		mi=cm.addRadioGroup('language');mi.setRadioCheck(g_LanguageID);
		mi=cm.addRadioGroup('iconsize');mi.setRadioCheck((g_iconSize<16)?0:1);
		cm.addNormalItem(null,'fontsize','');
		cm.addNormalItem(null,'colorsetup','');
		cm.addRadioGroup('resetskin');
		cm.addHRItem('treestruchhr');
		cm.addCheckItem('showcaption',null,this.bShowCaption);
		cm.addCheckItem('showroot',null,this.bShowRoot);
		cm.addCheckItem('showline',null,this.bShowLine);
		cm.addCheckItem('tabtooltip',null,this.bTabTooltip);
		cm.addHRItem('domainhr');
		cm.addCheckItem('autogroupbydomain',null,this.bAutoGroupByDomain);
		cm.addCheckItem('showsingletabdomain',null,this.bShowSingleTabDomain);
		cm.addHRItem('refreshhr');
		cm.addCheckItem('autorename',null,this.bAutoRename);
		cm.addCheckItem('shortdomain',null,this.bShortDomain);
		cm.addCheckItem('protecttab',null,this.bProtectTab);
		cm.addNormalItem(null,'autorenamemanager','');
		cm.addHRItem('treehr');
		cm.addCheckItem('autosyncenable',null,1);
		cm.addCheckItem('autohide',null,this.bAutoHide);
		cm.addHRItem('syshr');
		cm.addNormalItem(null,'float','');
		cm.addNormalItem(null,'reload','');
		cm.addHRItem('treehrglobal');
		cm.addNormalItem(null,'favmanager','');
		cm.addNormalItem(null,'help','');
		cm.build();
		return cm;
	}
	this.rebuildAllPopMenus=function()
	{
		this.getContextMenu('tab',true);
		this.getContextMenu('referrer',true);
		this.getContextMenu('group',true);
		this.getContextMenu('global',true);
	}
}//end of CTabTree
CTabTree.prototype.onClickSetupMenu=function(oMenuItem)
{
	this.getContextMenu('global').hide();
	if(!(oMenuItem.enabled))return false;
	var idstr=oMenuItem.sName;
	var type=idstr.substr(3,idstr.length-4);
	var idx=parseInt(idstr.substr(idstr.length-1,1))-1;
	if(oMenuItem.subMenu!=null && idx<0)return false;
	var oplist,old;
	try{oplist=eval('MLAN_'+type);}catch(e){oplist=null;}
	switch(type)
	{
	case 'language':
		g_LanguageID=idx;
		writeKey(type,oplist[idx+1][0]);
		this.TreeRoot.Title=Trans('tabtree');
		this.refreshTree(true);
		this.rebuildAllPopMenus();
		this.redraw();
		break;
	case 'iconsize':
		g_iconSize=(idx==0)?12:16;
		writeKey('iconsize',g_iconSize+'');	
		applyIni();
		this.refreshTree(true);
		break;
	case 'tabunderline':
		this.tabunderlineID=idx;
		writeKey(type,oplist[idx+1][0]);
		applyIni();
		break;
	case 'resetskin':
		loadIniToMem('config_default.ini');
		if(idx==1) loadIniToMem('config_user.ini');
		saveIni('config.ini');
		applyIni();	
		this.refreshTree(true);
		this.rebuildAllPopMenus();
		this.redraw();
		break;
	default:
		switch(idstr)
		{
		case 'fontsize':
			old=readKey('fontsize');
			old=parseInt(old);if(old<6 || old>30) old=14;
			old = this.Dlg.prompt(Trans('promptfontsize'),old.toString());
			if(old==null || old=='')return false;
			old=parseInt(old);
			if(old<6 || old>30)return false; 
			writeKey('fontsize',old+'px');	
			applyIni();
			this.refreshTree(true);
			break;
		case 'colorsetup': openDlgColorSetup(); break;
		case 'autosyncenable':
		{
			if(this.bAutoSync==0)
			{
				var tt = this.Dlg.prompt(Trans('promptperiod'),this.tSyncPeriod/1000);
				if(tt==null || tt=='')
				{
					oMenuItem.setCheck(0);
					return false;
				}
				tt=parseInt(tt); if(tt>20)tt=20;if(tt<1)tt=1;
				writeKey('refreshperiod',tt.toString());
				this.tSyncPeriod=tt*1000;
				onToggleTimer();
				this.setMyTimer();
			}
			else
			{
				onToggleTimer();
			}
			break;
		}
		case 'help': onHelp(); break;
		case 'reload': onReload();break;
		case 'float':openDlgTabtree();break;
		case 'autorenamemanager':openDlgEditAutorename();break;
		case 'favmanager':onFavorite();break;
		case 'tabtooltip':
			this.bTabTooltip=1-this.bTabTooltip;writeKey('tabtooltip',this.bTabTooltip.toString());
			this.refreshTree(true);break;
		case 'showcaption':
			this.bShowCaption=1-this.bShowCaption;writeKey('showcaption',this.bShowCaption.toString());
			if(this.bShowCaption) 	this.Dlg.maincaptionTR.style.display = "block";
			else 			this.Dlg.maincaptionTR.style.display = "none";
			break;
		case 'showroot':
			this.bShowRoot=1-this.bShowRoot;writeKey('showroot',this.bShowRoot.toString());
			this.refreshTree(true);break;
		case 'autohide':
			if('IMGBTNautohide' in this.Dlg)
				try{this.onClickAutoHide(this.Dlg.eval('IMGBTNautohide'));}catch(e){}
			else	this.bAutoHide=1-this.bAutoHide;	
			this.onMouseOutDelayed();
			break;
		case 'autorename':
			this.bAutoRename=1-this.bAutoRename;
			this.refreshTree(true);
			break;
		case 'protecttab':
			this.bProtectTab=1-this.bProtectTab;writeKey('protecttab',this.bProtectTab.toString());
			break;
		case 'shortdomain':
			this.bShortDomain=1-this.bShortDomain;writeKey('shortdomain',this.bShortDomain.toString());
			this.refreshTree(true);
			break;
		case 'showline':
			this.bShowLine=1-this.bShowLine;writeKey('showline',this.bShowLine.toString());
			this.refreshTree(true);break;
		case 'autogroupbydomain':
			this.bAutoGroupByDomain=1-this.bAutoGroupByDomain;
			writeKey('autogroupbydomain',this.bAutoGroupByDomain.toString());
			this.onToggleDomain();
			break;
		case 'showsingletabdomain':
			this.bShowSingleTabDomain=1-this.bShowSingleTabDomain;
			writeKey('showsingletabdomain',this.bShowSingleTabDomain.toString());
			this.onToggleSingleTabDomain();
			break;
		}
	}
	return false;
}
CTabTree.prototype.onClickNodeContextMenu=function(oMenuItem)
{
	if(!(oMenuItem.enabled))return false;
	var idstr,scope;
	var pItem=oMenuItem.parentMenu.parentItem;
	if(pItem==null)	{idstr=oMenuItem.sName;scope='_tab';}
	else		{idstr=pItem.sName;scope=oMenuItem.sName;}
	if(idstr.substr(0,5)=='group'){idstr=idstr.substr(5);scope='_group';}
	var uidstr=this.lastRightClickedItemStr.substr(3,this.lastRightClickedItemStr.length-3);
	var node=getNodeByUID(parseInt(uidstr));
	if(node==null)return false;
	switch(idstr)
	{
	case 'close': 		node.Tree.onClose(node,scope);break;
	case 'toggleread': 	node.onToggleRead(scope);break;
	case 'copytoclipboard': node.onCopyToClipboard(scope);break;
	case 'refreshpage': case 'savepage': case 'addtofavorite': case 'addtoblocklist':
				node.onBatchCommand(idstr,scope);break;
	case 'addautorename': 	node.onAddAutoRename();break;
	case 'setreferrer': 	node.onToggleAutoReferrer();break;
	case 'autorefreshpage': node.onAutoRefreshPage();break;
	case 'sortby':		node.onSort(scope);break;
	case 'newgroup': 	node.onNewGroup();break;
	case 'rename': 		node.onRename();break;
	case 'savetree': 	node.onExportTree();break;
	case 'loadtree': 	node.onImportTree();break;
	case 'pluginsetup': 	
		var oRootMenu=oMenuItem.parentMenu;
		while(oRootMenu.parentItem!=null) oRootMenu=oRootMenu.parentItem.parentMenu;
		if(oRootMenu) this.getContextMenu('global').show(oRootMenu.x+50,oRootMenu.y);
	}
	return false;
}
/* --------------------------------------- Tabtree Dialog ---------------------------------*/
function ___Tabtree_Dialog_____(){}
function openDlgTabtree(dim)//to miniziza when dim.h and dim.w less than zero (original size contained)
{
	if(g_dialogs.isAnyOpen())return;
if('document' in window) generateControlPanel(); 
else	alert('tabtree is not loaded: fatal error');
	var lastW=-100;
	var lastH=-100;
	var resizable=1;
	g_bDlgTabtreeReady=false;
	if(dim==null)
	{
		w=150;
		h=400;
		t=window.screenTop;
		l=window.screen.width-w-50;

		var temp;
		temp=readKey('lastX'); if(temp!=null)l=temp;	
		temp=readKey('lastY'); if(temp!=null)t=temp;	
		temp=readKey('lastW'); if(temp!=null)w=temp;	
		temp=readKey('lastH'); if(temp!=null)h=temp;	
	}
	else
	{
		t=dim.y;
		l=dim.x;
		if(dim.h<0)//minimize
		{
			resizable=0;
			lastW=-dim.w;
			lastH=-dim.h;
			w=100;
			h=100;
		}
		else
		{
			w=dim.w;
			h=dim.h;
		}
	}
	g_activeDlg= window.showModelessDialog("Dialog.htm",{"onload":"onLoadDlgTabtree","onunload":"onUnloadDlgTabtree","main":window,"lastW":lastW,"lastH":lastH}, "dialogHeight:"+h+"px;dialogWidth:"+w+"px;resizable:"+resizable+";status:0;help:0;scroll:0;dialogLeft:"+l+"px;dialogTop:"+t+"px");
}
function getDlgDims(winDlg,dim)
{
	if(winDlg.g_clientOffsetX>0 && winDlg.g_clientOffsetY >0 )
	{
		dim.x=winDlg.screenLeft-winDlg.g_clientOffsetX;
		dim.y=winDlg.screenTop-winDlg.g_clientOffsetY;
	}
	else
	{
		dim.x=parseInt(winDlg.dialogLeft);
		dim.y=parseInt(winDlg.dialogTop);
	}
	dim.w=parseInt(winDlg.dialogWidth);
	dim.h=parseInt(winDlg.dialogHeight);
}
function saveDims(dlg)
{
	if(dlg==window)return;
	if(dlg.g_lastW>0)return;//dont save for minimized dlg
	var dim=new Array();
	getDlgDims(dlg,dim);
	writeKey('lastX',(dim.x).toString());
	writeKey('lastY',(dim.y).toString());
	writeKey('lastW',(dim.w).toString());
	writeKey('lastH',(dim.h).toString());
}
var g_activeDlg=null;
var g_bDlgTabtreeReady=false;
var g_DictReferrer=new ActiveXObject("Scripting.Dictionary");
function CDictReferrer()
{
	this.Add=function(url, obj)
	{
		if(!g_DictReferrer.Exists(url)) g_DictReferrer.Add(url,new Array());
		g_DictReferrer.Item(url).push(obj);
	}
	this.Remove=function(url,uid)
	{
		if(!g_DictReferrer.Exists(url)) return;
		var i;
		for(i=0;i<g_DictReferrer.Item(url).length;i++)if((g_DictReferrer.Item(url))[i].UID==uid)break;
		if(i>=g_DictReferrer.Item(url).length) return;
		g_DictReferrer.Item(url).splice(i,1);
		if(g_DictReferrer.Item(url).length==0) g_DictReferrer.Remove(url);
	}
	this.Item=function(url)
	{
		if(!g_DictReferrer.Exists(url))return null;
		var to=g_DictReferrer.Item(url);
		if(to.length>1)
		{
			var cururl=null;
			try{ cururl=A_get_tab(external.cur_sel).document.URL; }catch(e){cururl=null;}
			if(cururl!=null && cururl==url)return getNodeForCurTab();
		}
		return (g_DictReferrer.Item(url))[0];
	}
	this.Exists=function(url)
	{
		return g_DictReferrer.Exists(url);
	}	
}
function getNodeForCurTab()
{
	try{
	var curtab =A_get_tab(external.cur_sel);	
	if(curtab!=null && ('UID' in curtab) && curtab.UID!=null && g_DictNodeByUID.Exists(curtab.UID))
		return g_DictNodeByUID.Item(curtab.UID);
	}catch(e){}
	return null;
}
function onReload() { location.reload(); }
function onMainMenu()
{
	if(g_dialogs.isAnyOpen() || !g_bDlgTabtreeReady)return;
	g_popMenus.checkClosePopMenus();
	var x,y;
	var eventWin;
	eventWin=g_TabTree.Dlg;
	x=eventWin.event.screenX+50;
	y=eventWin.event.screenY+50;
	g_TabTree.getContextMenu('global').show(x,y);
	g_popMenus.lastMenu=g_TabTree.getContextMenu('global');
	return true;
}
function onFavorite(dlg)
{
	var x,y;
	if(!dlg) { x=g_popClickX; y=g_popClickY; }
	else { x=dlg.event.screenX; y=dlg.event.screenY; }
	if(g_dialogs.isAnyOpen())return;
	g_dialogs.openDialog('',{"main":g_mainWin,"onload":"onLoadDlgFavTree","underNode":g_TabTree.TreeRoot, "bSelectOnly":0},x,y,500,400);
}
function onToggleTimer()
{
	g_TabTree.bAutoSync=1-g_TabTree.bAutoSync;	
	try{eval('ButtonAuto').src=(g_TabTree.bAutoSync==0)?"images/clock2r.gif":"images/clock2w.gif";}catch(e){}
}

var g_isFocus=false;
function onLoadDlgTabtree(dlg)
{
	dlg.g_lastW=dlg.dialogArguments.lastW;//>0 when it is mininized, <0 when normal
	dlg.g_lastH=dlg.dialogArguments.lastH;
	dlg.g_clientOffsetX=-1;
	dlg.g_clientOffsetY=-1;
	g_TabTree.redraw(dlg);
	try{A_get_tab(external.cur_sel).focus(); }catch(e){}
	g_isFocus=false;
}
function onUnloadDlgTabtree(dlg)
{
	/*--------*******0------------------*/
	if(g_FavTree && g_FavTree.Dlg)g_FavTree.Dlg.close();
	if(g_popMenus)g_popMenus.checkClosePopMenus();
	
	if(g_activeDlg==dlg)//when floatbar was closed by itself (not from mainwindow)
	{
		g_bDlgTabtreeReady=false;
		g_TabTree.Dlg=null;
		saveDims(dlg);
		g_TabTree.redraw(window);
		if(!g_bIsMyIE2)
		{
			//external.max_actSideBarItem(g_pluginName);
		}
	}
	else// floatbar was closed by mainwindow
	{
		saveDims(dlg);
	}
}
function onClickElsewhere()
{
	if(!g_TabTree.Dlg || !(g_TabTree.Dlg.event)) return false;
	try{
	var tid=g_TabTree.Dlg.event.srcElement.id;
	if(tid!='IMGBTNconfig' && tid!='IMGBTNIMGconfig' && g_popMenus)
		g_popMenus.checkClosePopMenus();
//	else 	alert(g_TabTree.Dlg.event.srcElement.id);
	}catch(e){}
//	g_TabTree.Dlg.focus();
	return false;
}


var CODE_SPLITER='=';
var CODE_LEFT='[';
var CODE_RIGHT=']';

function CFavTree(roottitle,refName)
{
	this.v_newNode=function(title) { return (new CFavNode(title,this)); }
	this.base=CTree;
	this.base(roottitle,refName);
	this.bShowRoot=1;
	this.bShowLine=1;
	this.bCheckTree=1;
	this.bSelectOnly=0;

//"virtual" functions
//	this.v_isDisabled=function() {return false;}
//	this.v_onMouseOut=function() { }
//	this.v_onMouseOver=function() { }
//	this.v_onGesture=function(tnode,gstr,lastButton){}
//	this.v_onDblClick=function(node,type,lastButton){}
//	this.v_onClick=function(node,type,lastButton){}
//	this.v_onMouseWheel=function(node,type,delta){}
//	this.v_getUpdatedContextMenu=function(type,node){return null;}
//	this.v_preRemoveNode=function(node){return true;}
//	this.v_postRemoveNodesUnder=function(pNode){}
//	this.v_needRefresh=function(bChanged, bForce) { return true; }
//	this.v_postRefreshTree=function() {}
//	this.v_postMoveNode=function(sNode,dNode,pos){}

//--------non virtual member functions
	this.importSubTreeOld=function(pnode,str)
	{
		function _divide(str)
		{
			function _idxMatchingRight(str,idxLeft)
			{
				if(str.charAt(idxLeft)!=CODE_LEFT)alert('error:non-[');
				var nLeft=0;
				for(var i=idxLeft;i<str.length;i++)
				{
					if(str.charAt(i)==CODE_LEFT)nLeft++;
					else if(str.charAt(i)==CODE_RIGHT)
					{	
						nLeft--;
						if(nLeft==0){return i;}
					}
				}
				return -1;
			}
			var childs=new Array();
			if(str.length==0)return childs;
			var idxLeft=0;
			var idxRight;
			while(idxLeft<str.length)
			{
				idxRight=_idxMatchingRight(str,idxLeft)
				if(idxRight<=0)break;
				childs.push(str.substr(idxLeft+1,idxRight-idxLeft-1));
				idxLeft=idxRight+1;
			}
			return childs;
		} 
		var tstr=str;
		var idxstar=str.indexOf(CODE_SPLITER);
		if(idxstar<0){return false;}
		var title=str.substr(0,idxstar);	
		title=unescape(title);

		str=str.substr(idxstar+1);
		var idxleft=str.indexOf(CODE_LEFT);
		var url;
		if(idxleft<0) url=str;
		else url=str.substr(0,idxleft);	
		var escfields=url.split('$');
		if(escfields.length<2)return;
		url=unescape(escfields[0]);
		var node;
		if(url!=null && url.length>0) node=pnode.addChildFavNode(title,url);
		else node=pnode.addChildGroup(title);
		if(idxleft>=0)
		{
			str=str.substr(idxleft,str.length-idxleft);
			var childs=_divide(str);
			for(var i=0;i<childs.length;i++)if(!(this.importSubTreeOld(node,childs[i])))return false;
			delete(childs);
		}
		return true;
	}
	this.loadTreeOld=function(fname)
	{
		var ta=loadUserFile(fname,1);
		if(ta==null){/*alert(fname+': invalid file format!'); */return false;}
		for(var idx=0;idx<ta.length;idx++)
		{
			if(!(this.importSubTreeOld(this.TreeRoot,ta[idx][0])))return false;
		}
		return true;
	}
	this.loadTree=function(filename)
	{
		var tt1=getCurTime();
		var list=loadUserFile(filename,1);
		var tt2=getCurTime();
		if(list==null){/*alert(fname+': invalid file format!');*/ return false;}
		var ret=this.importSubTree(this.TreeRoot,list,0,true);
		var tt3=getCurTime();
		return ret;
//		dumpMsg('filetime'+(tt2-tt1)+' importtime:'+(tt3-tt2));
	}
	this.saveTree=function(fname)
	{
		var t1=getCurTime();
		var str=this.TreeRoot.getSubTreeStr(false,true);
		A_writeFile(g_pluginName,fname,str);
		var t2=getCurTime();
	}
	this.deleteChecked=function()
	{
		this.removeNodesUnder(this.TreeRoot,'(oNode.bChecked)', false);
	}
	this.generateBodyHTML=function()
	{
		//Implementation of generateBodyHTML()
		var str;
		if(this.bSelectOnly)
		{
			str='<table width=100% height=100% style="table-layout:fixed"><tr><td class=StylePromptText height=30px>'+Trans('promptexport2')+'</td><td width=80%><input type="text" id="T1" class=StyleEditText></td></tr><tr><td class=StylePromptText style="vertical-align:top">'+Trans('promptexport1')+'</td><td><div style="border:1px solid #333333;width:100%;height:100%;vertical-align:top;overflow:auto;">'
		}
		else			str='';
		str+=this.getTreeDIVHTML();
		str+='<INPUT TYPE="file" style="display:none" NAME="BrowseG" onpropertychange="if(event.propertyName==\'value\') g_mainWin.g_filename=this.value;" >';
		if(this.bSelectOnly)
		{
			str+='</div></td></tr></table>';
		}	
		var bar;
		if(this.bSelectOnly==1)bar=new Array('buttonok','buttoncancel');
		else bar=new Array('buttonload','buttonimport','buttonrename','buttondelete','buttonsave','buttoncancel');
		str=getDlgFrameHTML('favtree',str,bar,'dlgFavTreeCmdRouter',!(this.bSelectOnly));
		return str;
	}//end of  function generateBodyHTML()
	this.renameAllChecked=function()
	{
		this.TreeRoot.visitAllA("(this.bChecked)", "this.onRename()");
		return;
	}
	this.getMinCheckedSubTreeList=function()
	{
		var nChecked=this.TreeRoot.getNumChecked();
		if(nChecked==0)return [];
		var oNode=this.TreeRoot.getFirstChecked();
		var nChecked2;
		while(oNode!=null)
		{
			nChecked2=oNode.getNumChecked();	
			if(nChecked2==nChecked) break;
			oNode=oNode.Parent;
		}
		if(oNode==null)oNode.TreeRoot;
		return oNode.getSubTreeList(true);
	}
	this.importFile=function(fname)
	{
		this.saveTree('data/favtree.txt.bak');
		fname=getRelativeFilename(fname);
		var ret=this.loadTreeOld(fname);
		if(!ret)
		{
			ret=this.loadTree(fname);
//			if(ret)alert('tree file (new version) is loaded successfully');
		}
//		else	alert('tree file (old version) is loaded successfully');
		if(ret)
		{
			this.refreshTree(true);
		}
		else
		{
			alert('invalid tree file format');
			this.removeNodesUnder(this.TreeRoot,'true', false);
			this.loadTree('data/favtree.txt.bak');
			this.refreshTree(true);
		}
	}
}//end of CFavTree(roottitle)

function getRelativeFilename(fname)
{
	var i,n=0;
	var pf=A_m2_plugin_folder(g_pluginName);
	for(i=0;i<pf.length;i++) if(pf.charAt(i)=='\\')n++;
	if(pf.substr(0,2).toLowerCase()!=fname.substr(0,2).toLowerCase())
	{
		alert('file should be in the same drive');
		return null;
	}
//	var idx=fname.lastIndexOf('\\');
//	fname=fname.substr(idx+1);
	fname=fname.substr(3);
	for(i=0;i<n-1;i++)fname='..\\'+fname;
	return fname;
}
function onBeforeUnloadMain()
{
	if(g_TabTree && g_TabTree.Dlg && g_TabTree.Dlg!=window) saveDims(g_TabTree.Dlg);
}
/* --------------------------- Main Window -----------------------------------*/
function ___MainWindow_____(){}
function generateControlPanel()
{
	window.document.ondragstart = nullHandler;
	window.document.ondrag = nullHandler;
	window.document.onmousedown=nullHandler;
	window.document.onmouseup=nullHandler;
	window.document.onmouseover=nullHandler;
	window.document.onmouseout=nullHandler;
	window.document.onmousemove=nullHandler;
	window.document.onmousewheel=nullHandler;
	window.document.onselect= nullHandler;
	window.document.onselectstart= nullHandler;
	window.document.onclick=onClickElsewhere;
	window.document.oncontextmenu=oldHandler;
	window.g_bEventAttached='0';
	
	var str='<TABLE CLASS=StylePanelTable>';//<TR height=16px>';
	str+='<tr><td class=StyleNoteText>'+Trans('mainnotes')+'</td></tr>';
	str+='</TABLE>';
	if("body" in window.document && window.document.body!=null) window.document.body.innerHTML=str; 
	else 				window.document.write(str);
	return str;
}
/* --------------------------------------- Dialogs ---------------------------------*/
function generateTextButtonTD(name,cmdrouterstr)
{
	var str='';
	var strclick=' onclick="g_mainWin.'+cmdrouterstr+'(window,\''+name+'\');"';
	str+='<TD align=center><DIV class=StyleTextButtonOut'+strclick;
	str+=' onmouseover="TB'+name+'.className=\'StyleTextButtonHover\'"';
	str+=' onmouseout="TB'+name+'.className=\'StyleTextButton\'"';
	str+=' title="'+Trans('title'+name)+'"><DIV id=TB'+name+' class=StyleTextButton';
	str+='>'+Trans(name)+'</DIV></DIV></TD>'; 
	return str;
}
function getDlgFrameHTML(title,innerhtml,buttonarray, cmdstr, bTitle)
{
	var str;
	str='<TABLE class=StylePanelTable cellpadding=0 cellspacing=0>';//---
//	if(bTitle) str+='<TR height=30px><TD class=StyleDialogCaption align=center background="images/caption.gif">'+Trans(title)+'</TD></TR>'
	if(bTitle) str+='<TR height=30px><TD class=StyleDialogCaption align=center>'+Trans(title)+'</TD></TR>'
//	if(bTitle) str+='<TR height=30px><TD class=StyleDialogCaption align=center>'+Trans(title)+'</TD></TR>'
	str+='<TR style="vertical-align:top;"><TD style="background-color:#F6F9FE">';
	str+=innerhtml;
	str+='</td></tr>';//--
	str+='<tr height=32px><td class=StyleDialogCaption><table width=100%><TR>';//--
	var i;
	for(i=0;i<buttonarray.length;i++)
	{
		str+=generateTextButtonTD(buttonarray[i],cmdstr);
	}
	str+='</TR></table></td></tr></table>';//---
	return str;
}
function CDialogs()
{
	this.dialogs=[];
	this.openDialog=function(title,args,x,y,w,h)
	{
		var dlg=window.showModelessDialog("dialog.htm",args, "dialogHeight:"+h+"px;dialogWidth:"+w+"px;resizable:1;status:0;help:0;scroll:0;dialogLeft:"+x+"px;dialogTop:"+y+"px");
		dlg.title=title;
		this.dialogs.push(dlg);
		dlg.holding=0;
	}
	this.isAnyOpen=function()
	{
		return (this.dialogs.length>0);
	}
	this.onUnloadDlg=function(dlg)
	{
		if(dlg.holding==1)return;
		var i;
		for(i=0;i<this.dialogs.length;i++)if(this.dialogs[i]==dlg)break;
		if(i>=this.dialogs.length){alert('fatal error');return;}
		var len=this.dialogs.length;
		var cdlg;
		while(i<len-1)
		{
			cdlg=this.dialogs.pop();
			cdlg.holding=1;
			cdlg.close();
			len--;
		}
		this.dialogs.pop();
		if(this.dialogs.length==0)
		{
			g_TabTree.Dlg.focus();
			g_isFocus=true;
		}
		else	this.dialogs[this.dialogs.length-1].focus();
	}

}
var g_dialogs=new CDialogs();

/* --------------------------------------- Color Setup Dialog ---------------------------------*/
function ___ColorSetupDlg_____(){}
function openDlgColorSetup()//called by main
{
	loadIniToMem();
	g_dialogs.openDialog('',{"main":g_mainWin,"onload":"onLoadDlgColorSetup"},g_popClickX,g_popClickY,400,450);
}
function onLoadDlgColorSetup(dlg)
{
	function generateForeBackTR(stylename)
	{
		function generateColorPickTD(optionname)
		{
			var str='';
			str+='<TD align=center><div id=oDiv'+optionname+' class=StyleColorpickDiv ';
			str+=' onclick="g_mainWin.dlgColorSetupCmdRouter(window,\''+optionname+'\');"';
			str+=' style="background-color:#'+ArrayKeyValues[optionname]+'"></div></TD>';
			return str;
		}
		var str='';
		str+='<TR  title="'+Trans('title'+stylename)+'">';
		str+='<TD><DIV id=oDiv'+stylename+'text';
		if(stylename.substr(stylename.length-5)!='color')
		{
			str+=' style="background-color:#'+ArrayKeyValues[stylename+'bg']+';';
			str+='color:#'+ArrayKeyValues[stylename+'fg']+';">';
			str+=Trans(stylename)+'</DIV></TD>';
			str+=generateColorPickTD(stylename+'fg');
			str+=generateColorPickTD(stylename+'bg');
			str+='<TD align=center><INPUT type=checkbox ';
			if(ArrayKeyValues[stylename+'bg']==ArrayKeyValues['backgroundcolor']) str+='CHECKED';
			str+=' id='+stylename+'check';
			str+=' onclick="g_mainWin.dlgColorSetupCmdRouter(window,\''+(stylename+'check')+'\');" CLASS=StyleCheckBox  HIDEFOCUS>';
			str+='</TD>';
		}
		else
		{
			if(stylename=='backgroundcolor')
			{
				str+='>'+Trans('backgroundcolor')+'</DIV></TD><TD>&nbsp;</TD>';
				str+=generateColorPickTD(stylename)+'<TD>&nbsp;</TD>';
			}
			else
			{
				str+='>'+Trans(stylename)+'</DIV></TD>';
				str+=generateColorPickTD(stylename)+'<TD>&nbsp;</TD><TD>&nbsp;</TD>';
			}
		}
		str+='</TR>';
		return str;
	}
	var i,str;
	str='<TABLE border=1 class=StyleTableSetupList style="width:100%;table-layout:fixed">';//TR--Body
	str+='<TR><TD class=StylePromptText align=center>'+Trans('style')+'</TD>';
	str+='<TD class=StylePromptText align=center>'+Trans('fgcolortext')+'</TD>';
	str+='<TD class=StylePromptText align=center>'+Trans('bgcolortext')+'</TD>';
	str+='<TD class=StylePromptText align=center>'+Trans('transparent')+'</TD></TR>';
	for(i=0;i<colorStyleList.length;i++) str+=generateForeBackTR(colorStyleList[i]);
	str+='</TABLE>';
	dlg.document.body.innerHTML=getDlgFrameHTML('colorsetupcaption',str,new Array('save','cancel'),'dlgColorSetupCmdRouter',true);
	dlg.document.title=dlg.title;
}
function dlgColorSetupCmdRouter(dlg,id)
{
	function callColorDlg(sInitColor)
	{
		var sColor;
		if (sInitColor == null) sColor = g_TabTree.Dlg.dlgHelper2.ChooseColorDlg();
		else 			sColor = g_TabTree.Dlg.dlgHelper2.ChooseColorDlg(sInitColor);
		sColor=sColor.toString(16);
		if (sColor.length < 6) sColor="000000".substring(0,6-sColor.length)+sColor;
		return sColor;
	}
	function applyColor(id,sColor)
	{
		var type,stylename;
		var objcolor= dlg.eval('oDiv'+id);
		var objtext;
		ArrayKeyValues[id]=sColor;
		objcolor.style.backgroundColor=sColor;
		if(id.substr(id.length-5)!='color')
		{
			type=id.substr(id.length-2,2);	
			stylename=id.substr(0,id.length-2);
			objtext=dlg.eval('oDiv'+stylename+'text');
			if(type=='fg') objtext.style.color=sColor;
			else if(type=='bg') objtext.style.backgroundColor=sColor;
			else{alert('invalid option name');return;}	
		}
		else
		{
			if(id=='backgroundcolor')
			{
				for(var i=0;i<colorStyleList.length;i++)
				{
					stylename=colorStyleList[i];
					if(stylename.substr(stylename.length-5)!='color')
					{
						objcolor=dlg.eval(stylename+'check');
						if(objcolor.checked)applyColor(stylename+'bg',sColor);
					}
				}
			}
		}
	}
	if(id in listStyleMap)
	{
		if(id.substr(id.length-2,2)=='bg' && dlg.eval(id.substr(0,id.length-2)+'check').checked)
		{ alert(Trans('changetransparent')); return false;}
		var sOldColor=ArrayKeyValues[id];
		var sColor=callColorDlg(sOldColor);
		if(sColor!=sOldColor) applyColor(id,sColor);
		return;
	}
	else
	{
		type=id.substr(id.length-5,5);	
		if(type=='check')
		{
			stylename=id.substr(0,id.length-5);	
			objtext=dlg.eval(id);
			if(objtext.checked) applyColor(stylename+'bg',ArrayKeyValues['backgroundcolor']);
		}
		else
		{
			if(id=='save') saveIni('config.ini');
			dlg.close();
			if(id=='save'){this.bTreeChanged=true;g_TabTree.redraw();}
		}
	}
}

/* --------------------------------------- Add Autorename Dialog ---------------------------------*/
function ___AddAutoRename_Dlg_____(){}
var g_listAutoRename=new Array();
function loadAutoRenameRules() 
{//based on a script created by mdlist
	var tArray=loadUserFile(g_autorenameFilename,5);
	g_listAutoRename=[];
	for (var i=0;i<tArray.length;i++)
	{
		if(tArray[i].length>4 && tArray[i][0]=='1')
		{
			g_listAutoRename.push(new Array(
				unescape(tArray[i][1]),
				unescape(tArray[i][2]),
				unescape(tArray[i][3]),	
				unescape(tArray[i][4])));
		}
	}
	delete tArray;
}
loadAutoRenameRules();

function openDlgAddAutorename(url, title)//(sName,sCmdRouter)
{
	g_dialogs.openDialog('',{"main":g_mainWin,"onload":"onLoadDlgAddAutorename","url":url, "title":title},g_popClickX,g_popClickY,350,320);
}
function onLoadDlgAddAutorename(dlg)
{
	var i;
	var str='<p class="StylePromptText">'+Trans('promptaddautorenameURL')+'<BR><input type="text" id="T1" class=StyleEditText></p>';
	str+='<p class="StylePromptText">'+Trans('promptaddautorenameTitle')+'<BR><input type="text" id="T2" class=StyleEditText></p>';
	str+='<p class="StylePromptText">'+Trans('promptaddautorenameReplace')+'<BR><input type="text" id="T3" class=StyleEditText></p>';
	dlg.document.body.innerHTML=getDlgFrameHTML('titleaddautorename',str,new Array('buttonok','buttoncancel'),'dlgAddAutorenameCmdRouter',true);
	dlg.T1.value=dlg.dialogArguments.url;
	dlg.T2.value=dlg.dialogArguments.title;
	dlg.T3.value='';
	dlg.T1.select();
	dlg.T1.focus();
	dlg.document.title=dlg.title;
}
function dlgAddAutorenameCmdRouter(dlg,actionstr)
{
	if(actionstr=='buttoncancel'){dlg.close();return;}

	var surl=escape(dlg.T1.value);
	var spretitle=escape(dlg.T2.value);
	var sreplace=escape(dlg.T3.value);
	var tarr=loadUserFile(g_autorenameFilename,5);
	var i;
	for(i=0;i<tarr.length;i++)//see if any conflictin rules (inter-contained)
	{
		if(tarr[i][1].indexOf(surl)==0 || surl.indexOf(tarr[i][1])==0)break;
	}
	if(i<tarr.length)
	{
		tarr[i][0]=1;
		tarr[i][1]=surl;
		tarr[i][2]='U';
		tarr[i][3]=spretitle;
		tarr[i][4]=sreplace;
	}
	else
	{
		var newele=['1',surl,'U',spretitle,sreplace,''];
		tarr.push(newele);
	}
	saveUserFile(g_autorenameFilename,tarr);
	loadAutoRenameRules();
	g_TabTree.refreshTree(true);
	dlg.close();
}
/* --------------------------------------- Edit Autorename Dialog ---------------------------------*/
function ___EditAutoRename_Dlg_____(){}
function getDlgEditAutoRenameHTML()
{
	var i;
	var str='<table  border=1 style="width:100%;table-layout:fixed"><TR>';//--
	str+='<TD class=StylePromptText align=center style="background-color:#cccccc">'+Trans('editautohead00')+'</TD>';
	str+='<TD class=StylePromptText align=center>'+Trans('editautohead0')+'</TD>';
	str+='<TD class=StylePromptText  style="width:27%">'+Trans('editautohead1')+'</TD>';
	str+='<TD class=StylePromptText  style="width:27%">'+Trans('editautohead2')+'</TD>';
	str+='<TD class=StylePromptText  style="width:27%">'+Trans('editautohead3')+'</TD>';
	str+='</TR>';
	for(i=0;i<g_listAutoRename.length;i++)
	{
		str+='<TR style="height:20px;padding:0">';
		str+='<TD align=center style="background-color:#cccccc"><INPUT type=checkbox id=CHKS'+i+' class=StyleCheckBox';
		str+=' HIDEFOCUS></TD>';
		str+='<TD align=center><INPUT type=checkbox id=CHKE'+i+' class=StyleCheckBox';
		if(g_listAutoRename[i][0]=='1') str+=' checked ';
		str+=' HIDEFOCUS></TD>';
		str+='<TD style="width:27%"><INPUT type=text class=StyleEditText ';
		str+='id=T1'+i;
		str+=' value="'+unescape(g_listAutoRename[i][1])+'"></TD>';
		str+='<TD style="width:27%"><INPUT type=text class=StyleEditText ';
		str+='id=T2'+i;
		str+=' value="'+unescape(g_listAutoRename[i][3])+'"></TD>';
		str+='<TD style="width:27%"><INPUT type=text class=StyleEditText ';
		str+='id=T3'+i;
		str+=' value="'+unescape(g_listAutoRename[i][4])+'"></TD>';
		str+='</TR>';
	}
	str+='</table>';//--
	return  getDlgFrameHTML('titleautorenamemanager',str,new Array('buttondelete','buttonsave','buttoncancel'),'dlgEditAutorenameCmdRouter',true);
}
function openDlgEditAutorename()
{
	g_dialogs.openDialog('',{"main":g_mainWin,"onload":"onLoadDlgEditAutorename"},g_popClickX,g_popClickY,700,350);
}
function dlgEditAutorenameCmdRouter(dlg,actionstr)
{
	var i;
	if(actionstr=='buttoncancel'){dlg.close();loadAutoRenameRules();return;}
	else if(actionstr=='buttonsave')
	{
		for(i=0;i<g_listAutoRename.length;i++)
		{
			if(dlg.eval('CHKE'+i).checked)	g_listAutoRename[i][0]='1';
			else					g_listAutoRename[i][0]='0';
			g_listAutoRename[i][1]=escape(dlg.eval('T1'+i).value);
			g_listAutoRename[i][3]=escape(dlg.eval('T2'+i).value);
			g_listAutoRename[i][4]=escape(dlg.eval('T3'+i).value);
		}
		saveUserFile(g_autorenameFilename,g_listAutoRename);
		loadAutoRenameRules();
		g_TabTree.refreshTree(true);
		dlg.close();return;
	}
	else if(actionstr=='buttondelete')
	{
		var n=g_listAutoRename.length;
		for(i=n-1;i>=0;i--)
		{
			if(dlg.eval('CHKS'+i).checked)
			{
				g_listAutoRename.splice(i,1);
			}
		}
		dlg.document.body.innerHTML=getDlgEditAutoRenameHTML();
	}
}
function onLoadDlgEditAutorename(dlg)
{
	g_listAutoRename=loadUserFile(g_autorenameFilename,5);
	dlg.document.body.innerHTML=getDlgEditAutoRenameHTML();
}
/* --------------------------- Favorite Dialog -----------------------------------*/
function ___FavTree_Dialog_____(){}
function onLoadDlgFavTree(dlg)
{
	if(g_FavTree!=null) delete g_FavTree;
	g_FavTree= new CFavTree(Trans('favtree'),'g_FavTree');//no child, expand, noindex
	if(dlg.dialogArguments.bSelectOnly==1) {g_FavTree.bCheckTree=0;g_FavTree.bSelectOnly=1;}
	applyIni(dlg);
	g_FavTree.Dlg=dlg;

	g_FavTree.loadTree(g_favtreeFilename);
	g_FavTree.refreshTree(true,1);
	if(dlg.dialogArguments.bSelectOnly==1)
	{
		g_FavTree.Dlg.T1.value=dlg.dialogArguments.underNode.Title;
		g_FavTree.Dlg.T1.select();
		g_FavTree.Dlg.T1.focus();
	}
	g_FavTree.Dlg.focus();
	//window.document.onselect= nullHandler;
	//window.document.onselectstart= nullHandler;
}
function unloadDlgFavTree(dlg)
{
	if(g_FavTree!=null)
	{
		g_FavTree.removeNodesUnder(g_FavTree.TreeRoot,"true",true);
		delete g_FavTree;
		g_FavTree=null;
	}
}
function blankTabFound()
{
	var i,found=0;
	try{for(i=0;i<external.tab_count;i++){if(A_get_tab(i).document.URL=='about:blank'){found=1;break;}}}catch(e){}
	if(found==1) alert(Trans('msgimport'));
	return found;
}
function dlgFavTreeCmdRouter(dlg,actionstr)
{
	if(actionstr=='buttoncancel'){unloadDlgFavTree(dlg);dlg.close();return;}
	if(actionstr=='buttonsave')
	{
		g_FavTree.saveTree(g_favtreeFilename);
		unloadDlgFavTree(dlg);
		dlg.close();
		g_TabTree.refreshTree();
		return;
	}
	if(actionstr=='buttondelete')
	{
		g_FavTree.deleteChecked();
		g_FavTree.refreshTree(true);
		return;	
	}
	if(actionstr=='buttonimport')
	{
		g_filename=null;
		dlg.BrowseG.click();
		if(g_filename==null){return;}
		g_FavTree.importFile(g_filename);
		return;
	}
	if(actionstr=='buttonload')
	{
		if(blankTabFound())return;
		var list=g_FavTree.getMinCheckedSubTreeList();
		if(list.length==0)return;
		g_TabTree.importSubTree(dlg.dialogArguments.underNode,list,0,false);
		unloadDlgFavTree(dlg);
		dlg.close();
		g_TabTree.refreshTree(true);
		return;
	}
	if(actionstr=='buttonok')
	{
		if(g_FavTree.lastSelectNode==null)
		{
			alert(Trans('promptselectnode'));
			return;
		}
		var oldTitle=dlg.dialogArguments.underNode.Title;
		dlg.dialogArguments.underNode.Title=dlg.T1.value;
		var list=dlg.dialogArguments.underNode.getSubTreeList(false);
		g_FavTree.importSubTree(g_FavTree.lastSelectNode, list, 0, false);
		dlg.dialogArguments.underNode.Title=oldTitle;
		g_FavTree.refreshTree(true);
		g_FavTree.saveTree(g_favtreeFilename);
		unloadDlgFavTree(dlg);
		dlg.close();
		return;
	}
	if(actionstr=='buttonrename')
	{
		g_FavTree.renameAllChecked();
		return;
	}
}
/* --------------------------------------- Setup ---------------------------------*/
function addRuleGroup(arr,rule,dlg) 
{
	if(dlg==null || !('mycss' in  dlg)){alert('err'); return;}
	for(var i=0;i<arr.length;i++) dlg.mycss.styleSheet.addRule(arr[i],rule); 
}
function onHelp()
{	
	openURLinNewTab('help/'+Trans('helpfile'),true);
}
function checkFirstTime()//check first time user
{
	var helpstr;
	var configfound= A_m2_readIni(g_pluginName,'config.ini','General','fontsize','');
	var temp= A_m2_readIni(g_pluginName,'config_default.ini','System','Installed','');
	if(temp==null || temp=='')
	{
		temp=navigator.systemLanguage;
		temp=(temp=='zh-cn')?'Chinese':'English';
		A_m2_writeIni(g_pluginName,'config_default.ini','General','language',temp);
		g_LanguageID=(temp=='Chinese')?1:0;

		A_m2_writeIni(g_pluginName,'config_default.ini','System','Installed','yes');
		
		if(configfound!=null && configfound!='') //config.ini was found
		{
			loadIniToMem('config.ini');
			saveIni('config.ini.bak');
			if(!window.confirm(Trans('msgwelcome')+Trans('msgrestoredefault')))
			{
				loadIniToMem('config.ini');
				saveIni('config.ini.bak');
				loadIniToMem('config_default.ini');
				saveIni('config.ini');
			}
			else
			{
				loadIniToMem('config_default.ini');
				loadIniToMem('config.ini');
				saveIni('config.ini');
			}
			helpstr='';
		}
		else	//config.ini was not found
		{
			loadIniToMem('config_default.ini');//create one from config_default.ini
			saveIni('config.ini');	
			helpstr=Trans('msgwelcome');
		}
		if(window.confirm(helpstr+Trans('promptreadhelp'))) onHelp();
	}
	else
	{
		if(configfound==null || configfound=='')
		{
			alert('config.ini was missing, restored from config_default.ini');
			loadIniToMem('config_default.ini');//create one from config_default.ini
			saveIni('config.ini');	
		}
	}
	temp=readKey('language');g_LanguageID=(temp=='Chinese')?1:0;
	g_bInSidebar=parseInt(readKey('insidebar'));
	if(g_bInSidebar!=0 && g_bInSidebar!=1)
	{
		g_bInSidebar=1;
		writeKey('insidebar',g_bInSidebar.toString());
	}
}
function applyIni(dlg)//apply setting in config.ini, called by main
{
	if(dlg==null)dlg=g_TabTree.Dlg;
	var temp;
	g_TabTree.tSyncPeriod=parseInt(readKey('refreshperiod'))*1000;if(g_TabTree.tSyncPeriod<1000 || g_TabTree.tSyncPeriod>10000) g_TabTree.tSyncPeriod=2000;
	temp=readKey('language');g_LanguageID=(temp=='Chinese')?1:0;

	g_TabTree.bShowRoot=parseInt(readKey('showroot'));
	if(g_TabTree.bShowRoot!=0 && g_TabTree.bShowRoot!=1)
	{
		g_TabTree.bShowRoot=1;
		writeKey('showroot',g_TabTree.bShowRoot.toString());
	}
	g_TabTree.bShowLine=parseInt(readKey('showline'));
	if(g_TabTree.bShowLine!=0 && g_TabTree.bShowLine!=1)
	{
		g_TabTree.bShowLine=1;
		writeKey('showline',g_TabTree.bShowLine.toString());
	}
	g_TabTree.bShowCaption=parseInt(readKey('showcaption'));
	if(g_TabTree.bShowCaption!=0 && g_TabTree.bShowCaption!=1)
	{
		g_TabTree.bShowCaption=0;
		writeKey('showcaption',g_TabTree.bShowCaption.toString());
	}
	g_TabTree.bTabTooltip=parseInt(readKey('tabtooltip'));
	if(g_TabTree.bTabTooltip!=0 && g_TabTree.bTabTooltip!=1)
	{
		g_TabTree.bTabTooltip=1;
		writeKey('tabtooltip',g_TabTree.bTabTooltip.toString());
	}
/*
	g_TabTree.bAutoRename=parseInt(readKey('autorename'));
	if(g_TabTree.bAutoRename!=0 && g_TabTree.bAutoRename!=1)
	{
		g_TabTree.bAutoRename=0;
		writeKey('autorename',g_TabTree.bAutoRename.toString());
	}
*/
	g_TabTree.bShortDomain=parseInt(readKey('shortdomain'));
	if(g_TabTree.bShortDomain!=0 && g_TabTree.bShortDomain!=1)
	{
		g_TabTree.bShortDomain=0;
		writeKey('shortdomain',g_TabTree.bShortDomain.toString());
	}
	g_TabTree.bProtectTab=parseInt(readKey('protecttab'));
	if(g_TabTree.bProtectTab!=0 && g_TabTree.bProtectTab!=1)
	{
		g_TabTree.bProtectTab=1;
		writeKey('protecttab',g_TabTree.bProtectTab.toString());
	}

	g_TabTree.bAutoGroupByDomain=parseInt(readKey('autogroupbydomain'));
	if(g_TabTree.bAutoGroupByDomain!=0 && g_TabTree.bAutoGroupByDomain!=1)
	{
		g_TabTree.bAutoGroupByDomain=1;
		writeKey('autogroupbydomain',g_TabTree.bAutoGroupByDomain.toString());
	}

	g_TabTree.bShowSingleTabDomain=parseInt(readKey('showsingletabdomain'));
	if(g_TabTree.bShowSingleTabDomain!=0 && g_TabTree.bShowSingleTabDomain!=1)
	{
		g_TabTree.bShowSingleTabDomain=1;
		writeKey('showsingletabdomain',g_TabTree.bShowSingleTabDomain.toString());
	}
	temp=readKey('fontsize');
	switch(temp)
	{
		case 'xx-small':temp=12;break;
		case 'x-small':temp=14;break;
		case 'small':temp=16;break;
		default: temp=parseInt(temp);if(temp<6 || temp>30) temp=14;
	}
	writeKey('fontsize',temp+'px');
	addRuleGroup(listStyleMap['fontsize'],'font-size:'+temp+'px',dlg);
	temp=readKey('iconsize');
	temp=parseInt(temp);if(temp!=12 && temp!=16) temp=12;
	writeKey('iconsize',temp+'');
	g_iconSize=temp;

	temp=readKey('tabunderline');
	if(temp!='underline' && temp!='none')
	{
		temp='underline';
		writeKey('underline',temp);
	}
	switch(temp)
	{
		case 'underline': g_TabTree.tabunderlineID=0;break;
		case 'none':	g_TabTree.tabunderlineID=1;break;
	}
	addRuleGroup(listStyleMap['tabunderline'], 'text-decoration:'+temp,dlg);	

	temp=readKey('backgroundcolor');
	addRuleGroup(listStyleMap['backgroundcolor'], 'background-color:#'+temp,dlg);
	temp=readKey('extrastylecolor');
	addRuleGroup(listStyleMap['extrastylecolor'], 'color:#'+temp,dlg);

	temp=readKey('tabiconreadcolor');
	if(temp==null || temp=='') temp='00FF00';
	g_tabIconReadColor=temp;

	temp=readKey('tabiconunreadcolor');
	if(temp==null || temp=='') temp='FF0000';
	g_tabIconUnreadColor=temp;

	var i,temp2;
	for(var i=0;i<colorStyleList.length;i++)
	{
		temp=colorStyleList[i];
		if(temp.substr(temp.length-5)=='color')continue;
		temp2=readKey(temp+'fg');
		addRuleGroup(listStyleMap[temp+'fg'], 'color:#'+temp2,dlg);
		temp2=readKey(temp+'bg');
		addRuleGroup(listStyleMap[temp+'bg'], 'background-color:#'+temp2,dlg);
	}
}
function saveIni(fname)
{for(var i=0;i<optionList.length;i++) writeOptionKeyFromMem(fname,optionList[i]);	}
function readKey(keyname,fname)
{
	var temp;
	if(fname==null) temp=A_m2_readIni(g_pluginName,'config.ini','General',keyname,'');
	else		temp=A_m2_readIni(g_pluginName,fname,'General',keyname,'');
	return temp;
}
function loadKey(keyname,fname)
{
	var temp=readKey(keyname,fname);
	if(temp==null || temp==''){return;}
	ArrayKeyValues[keyname]=temp;
}
function writeKey(keyname,valuestr,fname) 
{
	if(fname==null) A_m2_writeIni(g_pluginName,'config.ini','General',keyname,valuestr) 
	else		A_m2_writeIni(g_pluginName,fname,'General',keyname,valuestr) 
}
function writeOptionKeyFromMem(fname,keyname) { writeKey(keyname,ArrayKeyValues[keyname],fname);}
function loadIniToMem(fname) {for(var i=0;i<optionList.length;i++) loadKey(optionList[i],fname);} 
function generateColorOptionList()
{
	for(var i=0;i<colorStyleList.length;i++)
	{
		var str=colorStyleList[i];
		if(str.substr(str.length-5)=='color')colorOptionList.push(str);
		else {colorOptionList.push(str+'fg');colorOptionList.push(str+'bg');}
	}
}
var colorStyleList=['activestyle','hoverstyle','domainfoldedstyle','domainopenedstyle','tabstyle','unreadtabstyle','selectstyle','dropstyle','extrastylecolor','tabiconreadcolor','tabiconunreadcolor','backgroundcolor'];
var colorOptionList=new Array();
var ArrayKeyValues=new Array();
generateColorOptionList();
var optionList=colorOptionList;
optionList=optionList.concat(['tabunderline','refreshperiod','language','fontsize','iconsize','tabunderline','showroot','showline','autogroupbydomain','showsingletabdomain','showcaption','tabtooltip','shortdomain','lastX','lastY','lastW','lastH']);
var listStyleMap=new Array();
//listStyleMap['fontsize']=['.StyleSubTable'];
listStyleMap['fontsize']=['.StyleGroupFolded', '.StyleGroupOpened', '.StyleGroupDropable', '.StyleGroupNotDropable', '.StyleGroupHover', '.StyleGroupSelect', '.StyleTabActive', '.StyleTabNormal', '.StyleTabUnread', '.StyleTabDropable', '.StyleTabNotDropable', '.StyleTabHover', '.StyleTabExtra',  '.StyleTabSelect'];
listStyleMap['backgroundcolor']=['.StyleTreeDiv','.StyleSubTable'];
listStyleMap['tabiconreadcolor']=[];
listStyleMap['tabiconunreadcolor']=[];
//listStyleMap['tabunderline']=['.StyleTabActive', '.StyleTabNormal','.StyleTabExtra','.StyleTabHover'];
listStyleMap['tabunderline']=[];
listStyleMap['activestylefg']=['.StyleTabActive'];
listStyleMap['activestylebg']=['.StyleTabActive'];
listStyleMap['extrastylecolor']=['.StyleTabExtra'];
listStyleMap['hoverstylefg']=['.StyleTabHover','.StyleGroupHover'];
listStyleMap['hoverstylebg']=['.StyleTabHover','.StyleGroupHover'];
listStyleMap['domainfoldedstylefg']=['.StyleGroupFolded'];
listStyleMap['domainfoldedstylebg']=['.StyleGroupFolded'];
listStyleMap['domainopenedstylefg']=['.StyleGroupOpened'];
listStyleMap['domainopenedstylebg']=['.StyleGroupOpened'];
listStyleMap['tabstylefg']=['.StyleTabNormal','.StyleGroupNotDropable','.StyleTabNotDropable'];
listStyleMap['tabstylebg']=['.StyleTabNormal','.StyleGroupNotDropable','.StyleTabNotDropable'];
listStyleMap['unreadtabstylefg']=['.StyleTabUnread'];
listStyleMap['unreadtabstylebg']=['.StyleTabUnread'];
listStyleMap['selectstylefg']=['.StyleTabSelect','.StyleGroupSelect'];
listStyleMap['selectstylebg']=['.StyleTabSelect','.StyleGroupSelect'];
listStyleMap['dropstylefg']=['.StyleTabDropable','.StyleGroupDropable'];
listStyleMap['dropstylebg']=['.StyleTabDropable','.StyleGroupDropable'];
/* --------------------------- Startup Code -----------------------------------*/
function ___Startup_Code_____(){}
var g_FavTree=null;
checkFirstTime();
var g_TabTree= new CTabTree(Trans('tabtree'),'g_TabTree');
window.onbeforeunload=onBeforeUnloadMain;
if(g_bInSidebar==0) 
{
	if('document' in window) generateControlPanel();
	else	alert('tabtree is not loaded: fatal error');
	openDlgTabtree();
}
else	g_TabTree.redraw(window);

