/*************************************************************************************

=== Weather 4.40 ===

By Neo101
Previous versions by crino, Arkim, mdlist, seidenj and Tara
Created for Maxthon Tabbed Browser (www.maxthon.com)

=== License ===

Please contact Neo10 on forum.maxthon.com or www.neo101.nl if you would like to make any changes!
This plugin is for Maxthon only. You are not allowed to use it for any other program without permission.
Do not remove these comments/credits.
You are allowed to use/copy the icons. I did not create them.

Copyright 2005

Last modified 08-10-2005

=== Description of weather.js ===

Here are the variables declared and the main functions.


***************************************************************************************/

var SECURITY_ID	= max_security_id
var PLUGIN_NAME = "weather"

var showerr		= false
window.onerror	= ShowError

function ShowError(msg,url,line){
	var d 		= new Date()
	date		= d.getHours().toString()+':'+d.getMinutes().toString()+':'+d.getSeconds().toString()
	if(!showerr) external.get_tab(SECURITY_ID,external.cur_sel).window.status 
				= 'Message: '+msg+' Line: '+line+' URL: '+url+' Date: '+date
	showerr		= true
}


var activeLocation 	= readIni("Number")
if(activeLocation=='') 
	activeLocation 	= '1'
var locid 			= readIni("LocationCode"+activeLocation)
var activeCityName 	= readIni("LocationTxt"+activeLocation,'? , ?')
var units 			= readIni("units")
if(units=='') 
	units 			= 1
var futdays 		= readIni("FutureDays",'8');
var details 		= readIni("showDetails",'1')
var design 			= readIni("design")
var detlink 		= readIni("DetailsLink")
var style 			= readIni("StyleName")
var iconExtension 	= readIni("IconExtension")
var fontsize		= readIni("FontSize","MediumFonts.css")
var type 			= readIni('Type','1')
var showTodayDate 	= readIni('ShowDate','0')
var compactDisplay 	= readIni('compactDisplay','1')
var showWinAlways 	= readIni('ShowWin','0')
var cityLength 		= readIni('CityLength','3')
var titleAlign 		= readIni('TitleAlign','left')
var imageLocation 	= readIni('ImageSet','Type1_25')+'/'
var h24				= readIni('24Hours','1')
try{
	var interval 	= eval(readIni("Interval"));
} 
catch(err){ 
	var interval 	= 9999
}
var QuantLength 	= readIni("QuantityLength",'2')
if(QuantLength == 0) 
			compact = 0
else compact 		= 1
var pluginfolder	= external.m2_plugin_folder(SECURITY_ID,PLUGIN_NAME);
var name			= 'Weather'
var languageFile	= getLang()
var cityTra			= readFile("language/Language"+languageFile+".ini").toLowerCase().split('\r\n')
var errorMsg1		= trans('WT_error')+'<br><a href="'+scriptURL+'" target=_blank>'+locid+'</a><br>'+trans('WT_errorconn')
var errorMsg2		= trans('WT_error')+'<br><a href="'+scriptURL+'" target=_blank>'+locid+'</a><br>'+trans('WT_errorsupp')
var errorMsgCached	= '<b>'+trans('WT_noupdate')+'</b>'
var topicMsg		= '<span style="cursor:hand" title="'+trans("WT_ForumTopic")+
				'" onclick="window.open(\'http://forum.maxthon.com/forum/index.php?showtopic=22354\')">Weather 4.40</span>'
if(units == '0') 
	var unitsSym 	= ['F',trans('WT_mph'),trans('WT_mile'),trans('WT_inches')]
else var unitsSym 	= ['C',trans('WT_kmh'),trans('WT_km'),trans('WT_hPa')]
var monthname		= ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"]
var scriptURL, 
	dataall 		= 0, 
	noload 			= false, 
	goAnyway 		= false
data				= new Array()
var smallWindow		= ''

//constants

var IMG_LOCATION_MODDIALOG	= 'Type1_25/'
var FONT_SIZE_MODDIALOG		= 'SmallFonts.css'
var WEBPAGE_SUM 			= 'http://www.msnbc.com/m/chnk/d/weather_d_src.asp?acid='
var WEBPAGE_FUT 			= 'http://www.weather.com/weather/mpdwcr/tenday?locid='
var WEBPAGE_TODAY 			= 'http://www.weather.com/weather/mpdwcr/dailydetails?locid='
var WEBPAGE_LOCATION_SEARCH = 'http://xml.weather.com/search/search?where='

document.write('<link href="style/'+style+'" rel="stylesheet" type="text/css">')
document.write('<link href="style/'+fontsize+'" rel="stylesheet" type="text/css">')
document.write('<style>.titleleft{text-align:'+titleAlign+' !important;}</style>')

for(i=0;i<=cityLength;i++){
	eval('city'+i+' = readIni("LocationTxt'+i+'","? , ?")')
}

/*If no location is set */

if(locid == '') locid = 'NLXX0016'


function goAgain(dataall){
	top.dataall = dataall
	getDat()
	restart()
	showErrorMessage('')//remove old error messages
}

/*The data received from weather.com (summary)

function makeWeatherObj() { this.swCity = "Hong Kong"; this.swSubDiv = ""; this.swCountry = "China"; this.swRegion = "Asia"; this.swTemp = "84"; this.swTempCel = 
Math.round((5/9)*(this.swTemp-32)); this.swCIcon = "27"; this.swWindS = "17"; this.swWindD = "SSW"; this.swBaro = "29.68"; this.swHumid = "79"; this.swReal = "94"; this.swUV = "0"; this.swVis = 
"6.21"; this.swLastUp = "06/18/2005 07:00:00"; this.swConText = "Mostly Cloudy"; this.swFore = "7|1|2|3|4| 06/18/2005|06/19/2005|06/20/2005|06/21/2005|06/22/2005| 38|38|38|38|38| 
28|66|28|28|28| 88|89|89|89|87| 60|60|60|60|60| 47|47|47|47|47| 28|28|28|28|28| 82|82|82|81|80|"; this.swAcid = "ChXX0049"; }*/

/*Show the last update of the weather.com data */

function LastUpd() {
	try{
		var t="<a href='"+detlink+
			locid+"' target=_blank title='"+trans("WT_DetLinkTitle")+"'>"+trans("WT_DetLink")+"</a><br>"+
		trans("WT_Lastupdate");
		if(design==1) t+='<br>'
		t+=' '+updateTime
		document.all['lastUpdate'].innerHTML=t
	}	catch(err){}
}

/*Change the weather forecast type (summary, 10-day future)*/

function changeType(x){
	writeIni('Type',x)
	if(x==0) 	scriptURL 	= WEBPAGE_SUM+locid
	else if(x==1) scriptURL	= WEBPAGE_FUT+locid
	else if(x==2) scriptURL	= WEBPAGE_TODAY+locid
	type=x
	goAnyway=true
	reloadPage()
}

/*Get the correct day */

function getWeekday(n) {
	if(type==0) n--
	if(n<0) n+=7
	days	= ["WT_Sunday","WT_Monday","WT_Tuesday","WT_Wednesday","WT_Thursday","WT_Friday","WT_Saturday"]
	q		= trans(days[(n)])
	if(compact==1&&q.length>QuantLength+2) q='<span title="'+q+'">'+q.substring(0,QuantLength+2)+'</span>'
	return q
}

/*Save the state of the items (today/tomorrow/future) */

function switchstate(item) {
	var key	= item.replace(/title/gi,'Show')
	var x	= readIni(key)
	if(x == 0) 	writeIni(key,1)
	else 		writeIni(key,0)
	ExpandCollapse(item);
}

/* Shows today's date */

function showDate(x){
	var x=x.replace(/[^0-9,]*/g,'').split(',')
	if(type==1||type==2){
		var month = (eval(x[1])+1).toString()
		if(month.length==1) month='0'+month
		var year = x[0]
		var day  = x[2]
		if(day.length==1) day = '0'+day
	}
	else{
		var month	= x[0]
		var year	= x[2]
		var day		= x[1]
	}
	var date	= readIni('TodaysDate')
	date 		= date.replace(/dd/g,day).replace(/mm/g,month).replace(/yyyy/g,year)
	date 		= date.replace(/yy/g,year.substring(2,4)).replace(/Month/gi,trans('WT_'+monthname[(eval(month)-1)]))
	top.dateToday = date
}


/* Expand/Collapse the items */

function ExpandCollapse(item) {
	var key	= item.replace(/title/gi,'Show')
	var x	= readIni(key)
	var d	= key.replace(/Show/gi,'').toLowerCase()
	if(document.all['title'+d]==null) return
	if(x == 0) {
		document.all['title'+d].src = "images/plus.gif";
		var d=document.all["content"+d]
		if(d[0]) d[0].style.display = "none";
		else 	d.style.display 	= "none";
		if(d[1]) d[1].style.display = "none";
	} else {
		document.all['title'+d].src = "images/minus.gif";
		var d=document.all["content"+d]
		if(d[0]) d[0].style.display = "block";
		else 	d.style.display 	= "block";
		if(d[1]) d[1].style.display = "block";
	}
}

/* Expand/Collapse the items on start */

function setstates() {
	ExpandCollapse("titlenow")
	ExpandCollapse("titletoday")
	ExpandCollapse("titlefuture")
}

/* Auto-Update the window */

function doupdate () {
	if(interval==null||interval==9999||interval==0) return;
	else intVal=setTimeout("reloadPage()",1000*60*interval);
}

function showErrorMessage(x){
	document.all['error'].innerHTML=x
	if(x=='') document.all['error'].style.display='none'
	else document.all['error'].style.display='block'
}

/* start the retrieveHTML function (located in functionsWeather.js) */

function reloadPage(){
	retrieveHTML(scriptURL)
}

/* Set the active tab to bold */

function setFontWeight(){
	if(type==1){
		document.all['futu'].style.fontWeight	= 'bold'
		document.all['Summ'].style.fontWeight	= 'normal'
		document.all['Tod'].style.fontWeight	= 'normal'
	}
	else if(type==0){
		document.all['Summ'].style.fontWeight	= 'bold'
		document.all['futu'].style.fontWeight	= 'normal'
		document.all['Tod'].style.fontWeight	= 'normal'
	}
	else if(type==2){
		document.all['Summ'].style.fontWeight	= 'normal'
		document.all['futu'].style.fontWeight	= 'normal'
		document.all['Tod'].style.fontWeight	= 'bold'
	}
	if(cityLength!=1) {
		for(var i=1;i<=cityLength;i++){
			if(activeLocation!=i) eval('document.all["city'+i+'"].style.fontWeight = "normal"')
			else eval('document.all["city'+i+'"].style.fontWeight = "bold"')
		}
	}
	//Translate City + Country
	document.all['cityNameDisp'].innerHTML = transLoc(activeCityName)

}

/* Write the city tabs */

function City() {
	var t = ''
	var d = Math.round(100/(eval(cityLength)+2))
	if(cityLength==1) return
	for(var x=1; x<=cityLength; x++){
		t+='<td class=center width="'+d+'%">'+
				'<a id="city'+x+'" href="javascript:ChangeCity('+x+')" '+
					((activeLocation==x)?'style="font-weight:bold"':'')+
				' title="'+transLoc(eval('city'+x))+'">'+x+'</a>'+
			'</td>'
	}
	document.write(t)

	/*document.write('<a id="city'+x+'" href="javascript:ChangeCity('+x+')" '+((activeLocation==x)?'style="font-weight:bold"':'')+
		' title="'+transLoc(eval('city'+x))+'">'+x+'</a>')*/
}

/* Change city if the users clicks 1,2 or 3 */

function ChangeCity(x) {
	writeIni('Number',x)
	activeLocation = x
	if(name=='Config') {
		if(readIni("LocationTxt"+activeLocation)!='')
			document.all['cityNameDisp'].innerHTML=transLoc(readIni("LocationTxt"+activeLocation))
		else document.all['cityNameDisp'].innerHTML='? , ?'
		locid = readIni("LocationCode"+activeLocation)
		
		for(var i=1; i<=cityLength; i++){
			if(activeLocation!=i) eval('document.all["city'+i+'"].style.fontWeight = "normal"')
			else eval('document.all["city'+i+'"].style.fontWeight = "bold"')
		}
	}
	else {
		locid = readIni("LocationCode"+x)
		if(locid == '') {
			goConfig()
			document.all['cityNameDisp'].innerHTML='? , ?'
			setFontWeight()
			return
		}
		if(type==0) 	 scriptURL = WEBPAGE_SUM+locid
		else if(type==1) scriptURL = WEBPAGE_FUT+locid
		else 			 scriptURL = WEBPAGE_TODAY+locid
		goAnyway=true
		reloadPage()
	}
}

/* Is called when basic HTML page (weather.htm) finished loading 
 this function will start the retrieveHTML function to recieve the weather info 
 and set the right tab (in bold) + activeCityName on the HTML page*/

function start(){
	if(languageFile=='0002'||languageFile=='0016') {
			document.body.style.direction='RTL'//set the text alignment for the Arabic and Hebrew languagefiles to right to left
	}
	setFontWeight()
	if(type==0) 	 scriptURL 	= WEBPAGE_SUM + locid
	else if(type==1) scriptURL	= WEBPAGE_FUT + locid
	else if(type==2) scriptURL	= WEBPAGE_TODAY + locid
	retrieveHTML(scriptURL)
	
	//Blur all links when you click on them, makes everything a bit nicer.
	var d=document.links
	for(var i=0; i<d.length; i++){
		d[i].onfocus=function(){
			this.blur()
		}
	}
}

/* This function is started when all the data is recieved and loaded (by evaluate) */

function restart(){
	errorMsg1 = trans('WT_error')+'!<br><a href="'+scriptURL+'" target=_blank>'+locid+'</a><br>'+trans('WT_errorconn')
	errorMsg2 = trans('WT_error')+'!<br><a href="'+scriptURL+'" target=_blank>'+locid+'</a><br>'+trans('WT_errorsupp')
	
	setFontWeight()
	
	//noload is true when an error occures, so the weather data should not be showed, only an error message
	if(!noload) {
		loadPage()
		setstates()
		doupdate()
		LastUpd()
	} else {
		document.all['mainBody'].innerHTML='<div class=error>'+errorMsg1+'</div>'
		document.all['lastUpdate'].innerHTML=''
	}
}

/* Go to the configuration page */

function goConfig(){
	showErrorMessage('')
	document.all['configu'].style.display	= 'block'
	document.all['mainBody'].style.display	= 'none'
	document.all['typelinks'].style.display	= 'none'
	document.all['confTD'].disabled			= false
	oldLastUpd=document.all['lastUpdate'].innerHTML
	document.all['lastUpdate'].innerHTML	= ''
	document.all['configbox'].style.display	= 'block'
	document.all['weatherbox'].style.display= 'none'
	document.all['icon1'].src				= 'images/sun.gif'
	document.all['icon1'].parentElement.href= 'javascript:goWeather()'
	document.all['icon1'].title				= trans('WT_Weather')
	document.all['icon2'].parentElement.href= 'javascript:location.reload()'
	readPara()
	if(top.intVal!=null) window.clearInterval(intVal)
	name = 'Config'
	//These 2 lines fix an IE bug. If the configuration is clipped and you go back to the weather data the scrollbar is gone, but the page is still small.
	document.body.style.overflow = 'hidden'
	document.body.style.overflow = 'auto'
	if(smallWindow&&smallWindow!='') smallWindow.window.close()
}

/* Go to the weather page */

function goWeather(){
	if(locid=='') goConfig()
	if(type==0) 	 scriptURL = WEBPAGE_SUM+locid
	else if(type==1) scriptURL = WEBPAGE_FUT+locid
	else if(type==2) scriptURL = WEBPAGE_TODAY+locid
	clearRows(resultcontent)
	name = 'Weather'
	document.all['configu'].style.display	= 'none'
	document.all['mainBody'].style.display	= 'block'
	document.all['mainBody'].innerHTML		= trans('WT_loading')
	document.all['typelinks'].style.display	= 'block'
	document.all['confTD'].disabled			= true
	document.all['lastUpdate'].innerHTML	= oldLastUpd
	document.all['configbox'].style.display	= 'none'
	document.all['weatherbox'].style.display= 'block'
	document.all['icon1'].src				= 'images/config.gif'
	document.all['icon1'].parentElement.href= 'javascript:goConfig()'
	document.all['icon1'].title				= trans('WT_Setup')
	
	//These 2 lines fix an IE bug. If the configuration is clipped and you go back to the weather data the scrollbar is gone, but the page is still small.
	document.body.style.overflow = 'hidden'
	document.body.style.overflow = 'auto'
	
	//doupdate()
	reloadPage()
}

function nothing(){
	return true
}

/* Get the Maxthon language, and save it (only the firstRun time you load the plugin, after that it will only load the saved language) */

function getLang(){
	var firstRun = readIni("First")
	if(firstRun=='true') {
		try{
			var languageFile = external.max_language_id;
		}
		catch(err) {
			var languageFile=''
		}
		writeIni('First','false')
		if(external.m2_readIni(SECURITY_ID,PLUGIN_NAME,'/Language/Language'+languageFile+'.ini','Language','WT_Now','err')!='err')
			writeIni('Language',languageFile)
		else writeIni('Language','')
	}
	else var languageFile = readIni('Language')
	if(external.m2_readIni(SECURITY_ID,PLUGIN_NAME,'/Language/Language'+languageFile+'.ini','Language','WT_Now','err')=='err') 
		languageFile=''
	return languageFile
}


/* Show the small window */

function showWin(){
	smallWindow = external.max_modelessDialog(SECURITY_ID,"script/Dialog.htm",window,"dialogTop:"+readIni('WinTop')+
			"px;dialogLeft:"+readIni('WinLeft')+"px;status:0;help:0;scroll:0;"+
			"resizable:1;dialogHeight:"+readIni('WinHeight')+";dialogWidth:"+readIni('WinWidth')+";center:0;",window);
	document.all['showWinLink'].innerHTML	= trans('WT_CloseWin')
	document.all['showWinLink'].href		= 'javascript:smallWindow.window.close()'
}


/* Save the window size/position */

function savePos(x,y,z,a){
	writeIni('WinLeft',	x-4)
	writeIni('WinTop', 	y-30)
	writeIni('WinHeight', z)
	writeIni('WinWidth',  a)
	smallWindow = ''
	document.all['showWinLink'].innerHTML= trans('WT_OpenWin')
	document.all['showWinLink'].href	 = 'javascript:showWin()'
}

/*Read/write files */

function readFile(filename) {
	return external.readFile(SECURITY_ID,PLUGIN_NAME,filename)
}

function writeFile(filename,data) {
	external.writeFile(SECURITY_ID,PLUGIN_NAME,filename,data)
}

/*Read/Write Settings*/

function readIni(Key, errorResponse) {
	if(errorResponse==null) errorResponse=''
	return external.m2_readIni(SECURITY_ID,PLUGIN_NAME,"settings.ini","Settings", Key, errorResponse)
}

function writeIni(Key, Data) {
	external.m2_writeIni(SECURITY_ID,PLUGIN_NAME,"settings.ini","Settings", Key, Data+'')
}