function loadUserFile(fname,nCol)
{
	var tArray=new Array();
	var data = A_readFile(g_pluginName,fname);
	if(data==null) {alert('can not open '+fname); return null; }
	var lines = data.split("\r\n");
	var fields;
	for (var i=0; i<lines.length;i++)
	{
		fields=lines[i].split('|');
		if(fields.length<nCol || fields[0].length==0)continue;//alert('empty line');
		tArray.push(fields);
	}
	return tArray;
}
function saveUserFile(fname,tArray)
{
	var str='';
	var i,j;
	for (i=0;i<tArray.length;i++)
	{
		for(j=0;j<tArray[i].length;j++)
		{
			str+=tArray[i][j];
			if(j==(tArray[i].length-1)) 	str+='\r\n';
			else				str+='|';
		}
	}
	A_writeFile(g_pluginName,fname,str);
}
function openURLinNewTab(url,bActive)
{
	var curtab,i;
	var myname='GREATTABTREE';
	external.m2_callerName(g_pluginName);
	var oWin=window.open(url);
try{
	oWin.name=myname;
	for(i=0;i<external.tab_count;i++)
	{
		curtab=A_get_tab(i);
		if(curtab.window.name==myname)
		{
			if(bActive)A_activate_tab(i);//activate
			curtab.window.name=''; return curtab;
		}
} }catch(e){return null;}
	return null;
}
/* --------------------------------------- Debug Window ---------------------------------*/
function ___Debug_____(){}
var g_deferedMsgs=new Array();
var g_nMsgs=0;
var g_sMsgBuf='';
var g_idMsg=0;
function dumpLog(str)
{
	if(!g_bDumpLog)return;
	var str0;
	str0 = A_readFile(g_pluginName,'log.txt');
	if(str0==null)str0='';
	str0+=str+'\n';
	A_writeFile(g_pluginName,'log.txt',str0);
		
}
function dumpMsg(str)
{
	if(g_bShowDebugWin)
	{
		g_deferedMsgs.push(str);
		refreshDebugWin();
	}
}
function dumpObj(obj)
{
	var aa,str='';
	for(aa in obj)str+=aa+':'+obj[aa]+'\n';
	alert(str);
	window.clipboardData.setData("Text",str);
}
function getCurTime()
{
	var dt=new Date;
	var curt= dt.getTime();
	delete dt;
	return curt;
}
var g_timeStamps=new Array();
function timeStamp(str)
{
	if(!g_bShowDebugWin)return;
	g_timeStamps[str]=getCurTime();
}
function showTime(str1,str2)
{
	if(str1 in g_timeStamps && str2 in g_timeStamps) dumpMsg('from '+str1+' to '+str2+':'+(g_timeStamps[str2]-g_timeStamps[str1]));
}
/* --------------------------------------- Menu  ---------------------------------*/
var g_popMenuIDSeed=10;
var g_dictMenuItems=new Array();
function CMenu(objHost,scmdrouter)
{
	this.objHost=objHost;
	this.id='POP'+g_popMenuIDSeed;//dont really need it
	g_popMenuIDSeed++;
	this.items=new Array();
	this.oPopWin=null;
	this.x=0;
	this.y=0;
	this.width=0;
	this.height=0;
	this.bBuilt=false;
	this.parentItem=null;
	this.bHooked=false;
	this.sCmdRouter=scmdrouter;
	this.lastHighlightItem=null;
	this.addNormalItem=function(sIcon,sName,action)
	{
		var mi=new CMenuItem(this,'normal',sIcon,sName,action);
		this.items.push(mi); 
		return mi;
	}
	this.addHRItem=function(sName) { this.items.push(new CMenuItem(this,'hr',null,sName,null)); }
	this.addCheckItem=function(sName,action,bChecked)
	{
		var mi=new CMenuItem(this,'check',null,sName,action,bChecked);
		this.items.push(mi);
		return mi;
	}
	this.addRadioItems=function(sName,action,sIDGroup)
	{
		var found=false;
		var bChecked;
		var mi;
		for(var i=0;i<sIDGroup.length;i++)
		{
			if(sIDGroup[i]==sName)	{bChecked=1;found=true;}
			else			bChecked=0;
			mi=new CMenuItem(this,'radio',null,sIDGroup[i],action,bChecked,sIDGroup);
			this.items.push(mi);
		}
		if(!found)alert('invalid radio group');
		return mi;
	}
	this.addRadioGroup=function(sName)
	{
		var str,i,j,mi,mo;
		var ML=eval('MLAN_'+sName);
		var nLans=ML[0].length;
		var sIDGroup=new Array();
		for(j=0;j<ML.length;j++)
		{
			str='MLAN_PM_'+sName+j+'=[';
			for(i=0;i<nLans;i++)
			{
				str+='"'+ML[j][i]+'"';
				if(i==nLans-1)str+='];\n';
				else str+=',';
			}
			eval(str);
			if(j>0) sIDGroup[j-1]='PM_'+sName+j;
		}
		this.addNormalItem(null,'PM_'+sName+'0','');
		mo=new CMenu(this.objHost,'');
		mi=mo.addRadioItems(sIDGroup[0],'',sIDGroup);
		this.addSubMenuUnder('PM_'+sName+'0',mo);
		return mi;	
	}
	this.getHTML=function()
	{
		var str='';
		str+='<HTML><head><link type="text/css" rel="StyleSheet" href="css/menu.css"></head>';
		str+='<BODY CLASS=StyleMenuBODY>';
		str+='<DIV id='+'test'+' CLASS=StyleMenuDIVOuter>';
		str+='<DIV id='+this.id+' CLASS=StyleMenuDIV>';
		str+='<TABLE  cellspacing=0 cellpadding=0>';
		for(var i=0;i<this.items.length;i++)str+=this.items[i].getHTML();
		str+='</TABLE>';
		str+='</DIV>';
		str+='</DIV>';
		str+='</BODY></HTML>';
		return str;
	}
	this.getItemByID=function(id)
	{
		var idstr=this.id+id;
		if(!(idstr in g_dictMenuItems)){alert('invalid menuid='+idstr);return null;}
		return g_dictMenuItems[idstr];
	}
	this.checkItem=function(id,bchecked)
	{
		var o=this.getItemByID(id); if(o==null)return;
		o.bChecked=bchecked;
	}
	this.enableItem=function(id,benabled)
	{
		var o=this.getItemByID(id); if(o==null)return;
		o.enabled=benabled;
	}
	this.build=function()//create document for oPopWin and all it's childs
	{
		var i;
		if(this.oPopWin==null)//create popup
		{
			if(this.parentItem==null) 	{this.oPopWin=window.createPopup();}
			else this.oPopWin=this.parentItem.parentMenu.oPopWin.document.parentWindow.createPopup();
		}
		this.oPopWin.document.open( "text/html", "replace" )
		this.oPopWin.document.write(this.getHTML());
		this.oPopWin.document.close();
		this.oPopWin.document.oncontextmenu = nullHandler;
		this.oPopWin.document.ondragstart = nullHandler;
		this.oPopWin.document.ondrag = nullHandler;
		this.oPopWin.document.onselect= nullHandler;
		this.oPopWin.document.onselectstart= nullHandler;

		var tid,el;
		if(!(this.bHooked))
		{
			for(i=0;i<this.items.length;i++)
			{
				tid=this.items[i].id;
				el=this.oPopWin.document.getElementById(tid);
				if(this.items[i].type!='hr')
				{
			el.attachEvent('onmouseover',new Function('onMouseOverPopMenuItem("'+tid+'")'));
			el.attachEvent('onmouseout',new Function('onMouseOutPopMenuItem("'+tid+'")'));
			el.attachEvent('onclick', new Function('onMouseClickPopMenuItem("'+tid+'")'));
				}
			}
			if(this.parentItem==null)
				this.oPopWin.document.parentWindow.attachEvent('onunload',new Function(this.objHost.refName+".onPopMenuUnload()"));
			this.bHooked=true;
		}
		this.update(true);
		this.bBuilt=true;
	}
	this.update=function(bRebuild)
	{
		var i;
		for(i=0;i<this.items.length;i++) this.items[i].update();
		if(!bRebuild)return;
		this.oPopWin.show(-200,-200,1,1);
		var el=this.oPopWin.document.getElementById(this.id);
		var w=el.offsetWidth;
		var h=el.offsetHeight;
		for(i=0;i<this.items.length;i++)
		{
			this.getElementById(this.items[i].id).style.width=w+'px'; //for(i=0;i<this.items.length;i++)
			if(this.items[i].subMenu!=null)this.items[i].subMenu.build();
		}
		this.oPopWin.hide();
		this.width=w+6;
		this.height=h+12;
	}
	this.show=function(x,y)
	{
		if(!(this.bBuilt)||this.oPopWin==null) this.build();
		this.update(false);
		if(this.oPopWin.isOpen)return;// this.oPopWin.hide();
		if(this.parentItem==null) if(x>window.screen.width/2) x=x-this.width;
		this.oPopWin.show(x,y,this.width,this.height);
		var ww=this.oPopWin.document.parentWindow;
		this.x=ww.screenLeft;this.y=ww.screenTop;
	}
	this.hide=function()
	{
		if(this.oPopWin!=null && this.oPopWin && this.oPopWin.isOpen)
		{
			this.oPopWin.hide();
		}
	}
	this.getElementById=function(idstr)
	{
		return this.oPopWin.document.getElementById(idstr);
	}
	this.addSubMenuUnder=function(id,subMenu)
	{
		var idstr=this.id+id;
		if(!(idstr in g_dictMenuItems)){alert('id '+idstr+' does not exist addSubMenuUnder()');return;}
		var oItem=g_dictMenuItems[idstr];
		if(oItem.type=='hr'){alert('can not add submenu to <hr>: addSubMenuUnder()');return;}
		oItem.addSubMenu(subMenu)
	}
	this.isOpen=function() { return this.oPopWin.isOpen; }
}

function CMenuItem(parentMenu,type,sIcon,sName,action,bChecked,sIDGroup)
{
	this.parentMenu=parentMenu;
	this.type=type;//normal check hr radio
	//this.sIcon=sIcon;
	this.id=this.parentMenu.id+sName;
	this.sName=sName;
	this.action=action;
	this.subMenu=null;
	this.enabled=true;
	this.sIDGroup=null;
	this.bHideSubMenu=false;
	this.bHasIcon=false;
	if(type=='radio' || type=='check')
	{
		if(bChecked!=0 && bChecked!=1){alert('invalid bChecked value!');bChecked=0;}
	 	this.bChecked=bChecked;
		if(type=='radio') this.sIDGroup=sIDGroup;
	}
	else	this.bChecked=0;
	if(this.type!='hr')
	{
		if(this.id in g_dictMenuItems){alert('conflicting menu id: '+this.id);return;}
		g_dictMenuItems[this.id]=this;
	}
	this.subMenuOffsetX=function()
	{
		var el=this.parentMenu.getElementById(this.id);
		return el.offsetWidth;
	}
	this.subMenuOffsetY=function()
	{
		var el=this.parentMenu.getElementById(this.id);
		return el.offsetTop;
	}
	this.getExpandStr=function()
	{
		if(this.type=='hr') 		return '<hr>';
		else if(this.subMenu!=null && !(this.bHideSubMenu)) return '4';
		else	return '&nbsp;';
	}
	this.update=function()
	{
		var el,str,opacity;
		if(this.sIcon!=null)
		{
			el=this.parentMenu.getElementById('MICO'+this.id);
			opacity=(this.enabled)?100:20;
			if(this.type=='check' && !(this.bChecked) && !this.bHasIcon)opacity=0;
			el.style.filter='alpha(opacity='+opacity+')';
			el.style.backgroundColor=(this.bChecked)?'white':'transparent';
			el.style.border=(this.bChecked)?'1px solid #777777':'1px solid #DDDDDD';
		}
		else if(this.type=='radio')
		{
			el=this.parentMenu.getElementById(this.id+'TD1');
			if(this.bChecked==0)	el.innerHTML='&nbsp;';
			else			el.innerHTML='=';
		}
		el=this.parentMenu.getElementById(this.id+'TD3');
		el.innerHTML=this.getExpandStr();
		if(this.type!='hr')this.unhighlight();
//		this.unhighlight();
	}
	this.setColor=function(type)
	{
		var el;
		el=this.parentMenu.getElementById(this.id+'TD1');
		el.className='sMITD1'+type;
		el=this.parentMenu.getElementById(this.id+'TD2');
		el.className='sMITD2'+type;
		el=this.parentMenu.getElementById(this.id+'TD3');
		el.className='sMITD3'+type;
	}
	this.getHTML=function()
	{
		var str='';
		str+='<TR ID='+this.id+'>';
		str+='<TD nowrap CLASS=sMITD1EU ID='+this.id+'TD1>';
		if(this.type=='check')this.sIcon='checked.gif';
		if(this.sName in g_imagePool){this.sIcon=g_imagePool[this.sName];this.bHasIcon=true;}
		if(this.sIcon==null)
		{
			if(this.type=='hr') 			str+='<hr>';
			else str+='&nbsp;';
		}
		else
		{	this.sIcon='images/menu/'+this.sIcon;
			str+='<img ID=MICO'+this.id+' src="'+this.sIcon+'"';// width=12 height=12>';
		}
		str+='</TD>';
		str+='<TD nowrap ID='+this.id+'TD2 ';
		if(this.type!='hr')
		{
			str+=' CLASS=sMITD2EU title="'+Trans('title'+this.sName)+'">'+Trans(this.sName);
		}
		else	str+=' style="padding:0px"><hr>';
		str+='</TD><TD nowrap CLASS=sMITD3EU ID='+this.id+'TD3>';
		str+=this.getExpandStr();
		str+='</TD></TR>';
		return str;
	}
	this.addSubMenu=function(subMenu)
	{
		this.subMenu=subMenu;
		this.subMenu.parentItem=this;
	}
	this.tryShowSubMenu=function()
	{
		var other;
		for(var i=0;i<this.parentMenu.items.length;i++)
		{
			other=this.parentMenu.items[i];
			if(other.subMenu!=null && other.id!=this.id)other.subMenu.hide();	
		}
		if(this.subMenu!=null && !(this.bHideSubMenu))
		{
			var x=this.parentMenu.x+this.subMenuOffsetX()-2;
			var y=this.parentMenu.y+this.subMenuOffsetY()+2;
			this.subMenu.show(x,y); 
		}
	}
	this.highlight=function()
	{
		if(this.parentMenu.lastHighlightItem!=null) this.parentMenu.lastHighlightItem.unhighlight();
 		if(this.enabled) this.setColor('EH');
		else		this.setColor('DH');
		this.parentMenu.lastHighlightItem=this;
	}
	this.unhighlight=function()
	{
		if(this.enabled)this.setColor('EU');
		else		this.setColor('DU');
	}
	this.toggleCheck=function() { if(this.type=='check') this.bChecked=1-this.bChecked; }
	this.setCheck=function(bchecked) { if(this.type=='check') this.bChecked=bchecked; }
	this.setRadioCheck=function(idx)
	{
		if(idx!=null)
		{
			g_dictMenuItems[this.parentMenu.id+this.sIDGroup[idx]].setRadioCheck();
			return;
		}
		var oItem;
		for(var i=0;i<this.sIDGroup.length;i++)
		{
			oItem=g_dictMenuItems[this.parentMenu.id+this.sIDGroup[i]];
			oItem.bChecked=0;
		}
		this.bChecked=1;
	}
}
function onMouseOverPopMenuItem(idstr)
{
	if(!(idstr in g_dictMenuItems)){alert('invalid menuid');return false;}
	var oItem=g_dictMenuItems[idstr];
	oItem.highlight();
	oItem.tryShowSubMenu()
}
function onMouseOutPopMenuItem(idstr)
{
	if(!(idstr in g_dictMenuItems)){alert('invalid menuid');return false;}
	var oItem=g_dictMenuItems[idstr];
	if(oItem.subMenu!=null && oItem.subMenu.isOpen())return false;
	oItem.unhighlight();
}
var g_popClickX=0;
var g_popClickY=0;
function onMouseClickPopMenuItem(idstr)
{
	if(!(idstr in g_dictMenuItems)){alert('invalid menuid');return false;}
	var oItem=g_dictMenuItems[idstr];
	var lastClickPopWin=oItem.parentMenu.oPopWin.document.parentWindow;
	g_popClickX=lastClickPopWin.event.screenX;
	g_popClickY=lastClickPopWin.event.screenY;
	var oRootMenu=oItem.parentMenu;
	while(oRootMenu.parentItem!=null) oRootMenu=oRootMenu.parentItem.parentMenu;
	oRootMenu.hide();
	if(!(oItem.enabled)){oRootMenu.hide();return false;}
	var sAction=oRootMenu.sCmdRouter+'(oItem)';
//	if(oItem.subMenu!=null && !(oItem.bHideSubMenu)){oItem.tryShowSubMenu();return false;}
	if(oItem.type=='check')oItem.toggleCheck();
	else if(oItem.type=='radio')oItem.setRadioCheck();
	eval(sAction);
}
function CPopMenus()
{
	this.lastMenu=null;
	this.openMenu=function(pMenu)
	{
		this.lastMenu=pMenu;
	}
	this.isAnyOpen=function()
	{
		try{if(this.lastMenu && this.lastMenu.oPopWin.isOpen) return true;}catch(e){}
		return false;
	}
	this.checkClosePopMenus=function()
	{
		try{
		if(this.lastMenu && this.lastMenu.oPopWin.isOpen)
		{
			this.lastMenu.hide();
			this.lastMenu=null;
		}
		}catch(e){}
	}
}
var g_popMenus=new CPopMenus();
/* --------------------------------------- Node Classes  ---------------------------------*/
function getNodeByUID(uid)
{
	if(!g_DictNodeByUID.Exists(uid))return null;
	return g_DictNodeByUID.Item(uid);
}
//UID generator
var g_seedUID=999;
function getNextUID() { g_seedUID++; return (g_seedUID+getCurTime()); }
function sortFuncBase(n1,n2,key,dir)
{
	var key1=eval('n1.'+key);
	var key2=eval('n2.'+key);
	var d;
	if(key1<key2)		d= -1;
	else if(key1>key2) 	d= 1;
	else			d= 0;	
	return d*dir;
}
function sortFunc_nameA(n1,n2){return sortFuncBase(n1,n2,'Title',1); }
function sortFunc_nameD(n1,n2){return sortFuncBase(n1,n2,'Title',-1); }
function sortFunc_orderA(n1,n2){return sortFuncBase(n1,n2,'UID',1); }
function sortFunc_orderD(n1,n2){return sortFuncBase(n1,n2,'UID',-1); }

function CTreeNode(title,tree)
{
	this.UID = getNextUID();
	this.Title = title;     
	this.Tree=tree;
	this.Parent = null;
	this.Child = new Array();   
	this.bExpand = 1;
	this.bSelected=0;
	this.bChecked=0;
	g_DictNodeByUID.Add(this.UID,this);

//default implementation of "virtual" functions, overridable
	this.v_isHidden=function(){return false;}
	this.v_isDroppable=function(pos){return true;}
	this.v_isFoldable=function(type)
	{
		return (this.hasChild() && 
			!(!(this.v_isGroup()) && isTextType(type)) 
			&& !(this.Tree.bSelectOnly==1 && isTextType(type)));
	}
	this.v_isDraggable=function(){return (this.Parent!=null);}
	this.v_getFilterStr=function(){return '';}
	this.v_getNodeText=function() { return this.Title; }
	this.v_getToolTip=function(){return '';}
	this.v_getExtraStr=function() {return '';}
	this.v_closeAction=function(){}
	this.v_onSetHover=function() {this.setHover(); }
	this.addChildNode=function(node,idx)
	{
		if(idx==null) this.Child.push(node);
		else this.Child.splice(idx,0,node);
		node.Parent=this;
		return node;
	}
	this.addChildGroup=function(title,idx)
	{
		var tempnode=this.Tree.v_newNode(title);
		return this.addChildNode(tempnode,idx);
	}
	this.isLastChild=function()
	{
		var obj=this;
		if(obj.Parent==null) return true;//this is the root node
		return (obj==obj.Parent.Child[(obj.Parent.Child.length)-1]);
	}
	this.hasChild=function() { return (this.Child.length>0); }
	this.visitAll=function(conditionstr,actionstr,shareddata,returnrightnow)
	{
		var i,ret;
		for(i=this.Child.length-1;i>=0;i--)
		{
			ret=this.Child[i].visitAll(conditionstr,actionstr,shareddata,returnrightnow);
			if(ret && returnrightnow) return true;
		}
		if(conditionstr==null) eval(actionstr);//unconditionally
		else if(eval(conditionstr))
		{
			if(actionstr!=null) eval(actionstr);
			return true;
		}
		return false;
	}
	this.visitAllA=function(conditionstr,actionstr)
	{
		for(var i=0;i<this.Child.length;i++) this.Child[i].visitAllA(conditionstr,actionstr);
		if(eval(conditionstr) && actionstr!=null) eval(actionstr);
	}
	this.check=function(bChecked)
	{
		this.bChecked=bChecked;
		var b=bChecked?true:false;
		var obj=this.Tree.getObj('CHK'+this.UID);
		if(obj)obj.checked=b;
	}
	this.checkAll=function(bChecked)
	{
		this.visitAllA('true','this.check('+bChecked+')');
		var b=bChecked?true:false;
	}
	this.getCONIcon=function()
	{
		var fstr='ftv2';
		if(this.hasChild() || this.Parent==null)
		{
			if(this.bExpand==1) fstr+='m';
			else fstr+='p';
			if(this.Parent==null)	fstr+='root';
		}
		if(this.isLastChild() && this.Parent!=null) fstr+='last';
		fstr+='node.gif';
		return 'tree/'+fstr;
	}
	this.getRelativeIndex=function()//get index in the child Array
	{
		if(this.Parent==null) return 0;//rootnode
		for(var i=0;i<this.Parent.Child.length;i++)
			if(this==this.Parent.Child[i])return i;
		return -1;
	}
	this.isDroppable=function(pos)
	{
		if(!(this.v_isDroppable(pos)))return false;
		var tobj=this;
		while(tobj!=null)//can not drag under or beside it's child node
		{
			if(tobj==g_mouse.lastDownNode) return false;
			tobj=tobj.Parent;
		}
		switch(pos)
		{
		case 0: if(pos==0 && g_mouse.lastDownNode.Parent==this)return false;else return true;
		case -1:
		case 1:
			if(this.Parent==null/* || this.hasChild() && pos==1 && this.bExpand==1*/)return false;//can not beside parent
			var idx=this.getRelativeIndex();
			if(idx<0)return false;
			idx+=pos;
			if(idx<0 || idx>=this.Parent.Child.length)return true;
			if(this.Parent.Child[idx]==g_mouse.lastDownNode) return false;
		}
		return true;
	}
	this.setSpecialStyle=function(newclassname)
	{
		var oTXA=this.Tree.getObj('TXA'+this.UID);
		if(oTXA && (oTXA.className=='StyleTabNormal' || oTXA.className=='StyleTabUnread' || newclassname!='StyleTabActive')) oTXA.className=newclassname;
	}
	this.redrawNode=function()
	{
		var obj=this.Tree.getObj('TXA'+this.UID);
		if(obj) obj.title=this.v_getToolTip();
		obj=this.Tree.getObj('TXT'+this.UID);
		if(obj) obj.innerText=this.v_getNodeText();
		this.redrawIcon();
		if(this.hasChild())
		{
			obj=this.Tree.getObj('CLD'+this.UID);
			if(obj) obj.style.display = (this.bExpand==1)?"block":"none";
		}
		obj=this.Tree.getObj('CON'+this.UID);
		if(obj)obj.src='images/'+this.getCONIcon();
		obj=this.Tree.getObj('TXE'+this.UID);
		if(obj)obj.innerText=this.v_getExtraStr();
		this.redrawStyle();
	}
	this.redrawIcon=function()
	{
		var obj=this.Tree.getObj('ICO'+this.UID);
		var fstr=null;
		var fname;
		if(obj)	
		{
			fname='images/'+this.v_getNodeIcon();
			try{if(fname!=obj.src)obj.src=fname;}catch(e){alert('22222')}
			fstr=this.v_getFilterStr();
			if(fstr)obj.style.filter=fstr;
		}
	}
	this.redrawStyle=function()
	{
		var oTXA=this.Tree.getObj('TXA'+this.UID);
		if(oTXA) oTXA.className=this.v_getStyleClassName();
	}
	this.getSubTreeStr=function(bOnlyChecked, bSkipRoot)
	{
		var oStr=CreateFastString(5000);
		this.getSubTreeStrBase(0,bOnlyChecked,oStr,bSkipRoot)
		return oStr.concat();
	}
	this.getSubTreeStrBase=function(level,bOnlyChecked,oStr,bSkipRoot)
	{
		if(bOnlyChecked && this.getNumChecked()==0) return;
		if(!(bSkipRoot && level==0))
		{
			if(!(this.v_getNodeDataStr(level,bOnlyChecked,oStr)))return;
		}
		for(var ii=0;ii<this.Child.length;ii++)
		{
			this.Child[ii].getSubTreeStrBase(level+1,bOnlyChecked,oStr);
		}
	}
	this.getSubTreeList=function(bOnlyChecked)
	{
		var list=new Array;
		this.getSubTreeListBase(0,bOnlyChecked,list)
		return list;
	}
	this.getSubTreeListBase=function(level,bOnlyChecked,list)
	{
		if(bOnlyChecked && this.getNumChecked()==0) return;
		var data=this.v_getNodeData([level],bOnlyChecked);
		if(data==null)return;
		list.push(data);
		var ii;
		for(ii=0;ii<this.Child.length;ii++)
		{
			this.Child[ii].getSubTreeListBase(level+1,bOnlyChecked,list);
		}
	}
	this.setDrop=function(pos)
	{
		var type, dropUnder;
		var obj=this.Tree.getObj('dragSep');
		if(!obj)return;
		obj.style.visibility = "hidden";	
		if(this.isDroppable(pos))
		{
			this.Tree.dropNode=this;
			this.Tree.dropPos=pos;
			if(pos!=0)
			{
				obj.style.visibility = "visible";
				dropUnder=null;//this.Parent;	
			}
			else	dropUnder=this;
			type='';
		}
		else
		{
			this.Tree.dropNode=null;
			type='Not';
			dropUnder=this;
		}
		this.Tree.clearDrop();
		if(dropUnder==null)return;
		if(dropUnder.v_isGroup()) type='Group'+type;
		else			type='Tab'+type;
		var className='Style'+type+'Dropable';
		dropUnder.setSpecialStyle(className);
		this.Tree.lastDropNode=dropUnder;
	}
	this.setSelect=function(bSelected)
	{
		if(bSelected==false)
		{
			this.Tree.lastSelectNode.bSelected=0;
			this.Tree.lastSelectNode.redrawStyle();
			this.Tree.lastSelectNode=null;
			return;
		}
		if(this.Tree.lastSelectNode)
		{
			this.Tree.lastSelectNode.bSelected=0;
			this.Tree.lastSelectNode.redrawStyle();
		}
		var type;
		if(this.v_isGroup()) type='Group';
		else		   type='Tab';
		this.setSpecialStyle("Style"+type+"Select");
		this.Tree.lastSelectNode=this;
		this.bSelected=1;
	}
	this.setHover=function()
	{
		this.Tree.clearHover();
		var cname=(this.v_isGroup())?"StyleGroupHover":"StyleTabHover";
		try{
			this.setSpecialStyle(cname);
			this.Tree.lastHoverNode=this;
		}catch(e){}
	}
	this.getFirstChecked=function()
	{
		var sData=new Array();
		sData.oNode=null;
		this.visitAll("(this.bChecked)","shareddata.oNode=this;",sData,true);
		return sData.oNode;
	}
	this.getNumChecked=function()
	{
		var sData=new Array();
		sData.nChecked=0;
		this.visitAll("(this.bChecked)","shareddata.nChecked++;",sData,false);
		return sData.nChecked;
	}
}

/* ---------------------------- gesture handler -------------------------*/
var g_EnumGestureDirection=new Array('NONE','UP','DOWN','LEFT','RIGHT');
function CGestureHandler()
{
	this.const_gestureDeltaX=new Array(0,0,0,-1,1);
	this.const_gestureDeltaY=new Array(0,-1,1,0,0);
	this.const_graceDistance=50;
	this.const_graceMargin=20;
	this.const_nNoiseMargin=5;
	this.m_gestrueMinDistance=20;
	this.EnumGestureDirection=new Array(new Array(1,4),new Array(3,2));
	this.MAX_GESTURE_SEGMENTS=3;

	this.m_lastX=0;
	this.m_lastY=0;
	this.m_anchors_x=new Array();
	this.m_anchors_y=new Array();
	this.m_anchors_dir=new Array();
	this.m_iAnchor=0;
	this.GetDirection=function(dx,dy)
	{
		var divyx=(dy>dx)?1:0;
		var divy_x=(dy>-dx)?1:0;
		return this.EnumGestureDirection[divyx][divy_x];
	}
	this.InValidRegion=function(offx,offy,dir)
	{
		var margin,m,d;
		if(dir==2 || dir==1)	{m=offx;d=offy;}
		else				{m=offy;d=offx;}
		if(d<this.const_graceDistance && d>-(this.const_graceDistance))	margin=this.const_nNoiseMargin;
		else					margin=this.const_graceMargin;
		if(m<margin && m>-margin)return true;
		else return false;
	}
	this.DirectionReversed=function(offx,offy, dir)
	{
		var sx,sy;
		sy=(offy>=0)?1:-1;
		sx=(offx>=0)?1:-1;
		if(dir==1 || dir==2)	return (this.const_gestureDeltaY[dir]!=sy);
		else				return (this.const_gestureDeltaX[dir]!=sx);
	}
	this.TrySetDirection=function(offx,offy)
	{
		if(offx>=this.m_gestrueMinDistance || offx<=-this.m_gestrueMinDistance 
		|| offy>=this.m_gestrueMinDistance || offy<=-this.m_gestrueMinDistance)//out of margin
		{
			var tdir=this.GetDirection(offx,offy);
			if(this.InValidRegion(offx,offy,tdir))this.m_anchors_dir[this.m_iAnchor]=tdir;
			return true;
		}
		else return false;
	}
	this.SetAnchor=function(x,y)
	{
		if(this.m_iAnchor>=this.MAX_GESTURE_SEGMENTS-1)return;
		this.m_iAnchor++;
		this.m_anchors_x[this.m_iAnchor]=x;
		this.m_anchors_y[this.m_iAnchor]=y;
		this.m_anchors_dir[this.m_iAnchor]=0;
		this.m_anchors_dir[this.m_iAnchor+1]=0;
	}
	this.reset=function() { this.m_iAnchor=-1; }
	this.SetStartPoint=function(x,y)
	{
		this.reset();
		this.SetAnchor(x,y);
	}
	this.onMouseMove=function(x,y)
	{
		if(this.m_iAnchor<0 || this.m_iAnchor>=this.MAX_GESTURE_SEGMENTS-1)return;//assure the mouse is holding
		var offx=x-this.m_anchors_x[this.m_iAnchor];
		var offy=y-this.m_anchors_y[this.m_iAnchor];
		var curdir=this.m_anchors_dir[this.m_iAnchor];
		if(curdir==0)//still in noise region
		{
			this.TrySetDirection(offx,offy);
			if(!this.InValidRegion(offx,offy,this.m_anchors_dir[this.m_iAnchor])) this.reset();
		}
		else//check direction change
		{
			var isValid=this.InValidRegion(offx,offy,curdir);
			var reloffx=x-this.m_lastX;
			var reloffy=y-this.m_lastY;
			if(!isValid || this.DirectionReversed(reloffx,reloffy,curdir))
			{
				var nx=this.m_lastX;
				var ny=this.m_lastY;
				if(!isValid)//recalculate anchor point
				{
					if(curdir==1 || curdir==2)
					{
						nx=this.m_anchors_x[this.m_iAnchor];
						ny=this.m_lastY;
					}
					else
					{
						ny=this.m_anchors_y[this.m_iAnchor];
						nx=this.m_lastX;
					}
					reloffx=x-nx;
					reloffy=y-ny;
				}
				this.SetAnchor(nx,ny);
				this.TrySetDirection(reloffx,reloffy);
				if(!this.InValidRegion(reloffx,reloffy,this.m_anchors_dir[this.m_iAnchor])) this.reset();
			}
		}
		this.m_lastX=x;
		this.m_lastY=y;
	}
	this.reset();
};
function CMouse()
{
	this.reset=function()
	{
		this.state=0;//0:reset, 1:first down (record node and x,y), 2:drag and out
		//this.lastDownNode=null;
		this.gesture.reset();
	}
	this.getGesture=function()
	{
		var str='';
		if(this.gesture.m_iAnchor>=0)
		{
			for(var i=0;i<=this.gesture.m_iAnchor;i++)
			{
			  //str+=g_EnumGestureDirection[g_mouse.gesture.m_anchors_dir[i]];
			  if(this.gesture.m_anchors_dir[i]!=0)str+=this.gesture.m_anchors_dir[i];
			}
		}
		return str;	
	}
	this.startDblClickTimer=function(tnode)
	{
		this.dblClickTimerID=setTimeout("g_mouse.clearDblClickTimer()",200);
		this.dblClickLastUID=tnode.UID;
	}
	this.clearDblClickTimer=function()
	{
		if(this.dblClickTimerID!=null)
		{
			clearTimeout(this.dblClickTimerID);
			this.dblClickLastUID=null;
			this.dblClickTimerID=null;
		}
	}
	this.dblClickLastUID=null;
	this.dblClickTimerID=null;
	this.lastButton=0;
	this.gesture=new CGestureHandler();
	this.reset();
	this.state=0;
	this.lastDownNode=null;
	this.wheelDir=0;
}
var g_mouse=new CMouse();

function nullHandler(){ try{if(window.event.ctrlKey)return true;}catch(e){} return false; }
function oldHandler(){ return true; }
var g_DictNodeByUID=new ActiveXObject("Scripting.Dictionary");//maintained by CTabNode
var g_mainWin=window;
var g_iconSize=12;
function ___CTree_____(){}
function isNodeType(type)
{
	return (type=='TXA' || type=='TXT' || type=='TXE' || type=='ICO'  || type=='CON' || type=='CHK');	
}
function isTextType(type)
{
	return (type=='TXA' || type=='TXT' || type=='TXE');	
}
function CTree(roottitle,refName)
{
	this.TreeRoot=this.v_newNode(roottitle);
	this.refName=refName;
	this.lastActiveNode=null;
	this.lastSelectNode=null;
	this.lastHoverNode=null;
	this.lastDropNode=null;
	this.dropNode=null;
	this.dropPos=null;
	this.Dlg=null;
	this.bUseFilter=false;
	this.lastRightClickedItemStr=null;
	this.bDraggable=true;
	this.bTreeChanged=true;
	this.contextMenus=[];
	this.bClearEmptyFolders=false;
//------------------- Default implementation of "virtual" functions
	this.v_isDisabled=function() {return false;}
	this.v_onMouseOut=function() { }
	this.v_onMouseOver=function() { }
	this.v_onGesture=function(tnode,gstr,lastButton){}
	this.v_onDblClick=function(node,type,lastButton){}
	this.v_onClick=function(node,type,lastButton){}
	this.v_onMouseWheel=function(node,type,delta){}
	this.v_getUpdatedContextMenu=function(type,node){return null;}
	this.v_preRemoveNode=function(node){return true;}
	this.v_postRemoveNodesUnder=function(pnode){}
	this.v_needRefresh=function(bChanged, bForce) { return true; }
	this.v_postRefreshTree=function() {}
	this.v_postMoveNode=function(sNode,dNode,pos){}
	this.v_onDrop=function(snode,dnode,pos){this.onDrop(snode,dnode,pos);}
//------------------- non-virtual functions -----------------------
	this.onDrop=function(snode,dnode,pos)
	{
		var ppnode=snode.Parent;
		this.moveNode(snode,dnode,pos);
		if(this.bClearEmptyFolders)this.clearEmptyAncestorFolders(ppnode);
		this.refreshTree(true);
	}
	this.clearEmptyAncestorFolders=function(pNode)
	{
		var tNode;
		while(pNode!=null)//clear all empty ancestor folders
		{
			tNode=pNode;
			pNode=pNode.Parent;
			if(tNode.URL==null && !tNode.hasChild())this.removeNode(tNode);
		}
	}
	this.getObj=function(id)
	{
		return this.Dlg.document.all[id];
	}
	this.spliceNode=function(node)
	{
		var parentobj=node.Parent;
		var idx=node.getRelativeIndex();
		if(idx>=0) return parentobj.Child.splice(idx,1);	//remove current node from childs
		else return null;
	}
	this.removeNode=function(node)
	//will only remove leaf node
	{
		if(node.Parent==null || !(this.v_preRemoveNode(node)))return;//do not remove root node
		if(!node.hasChild())//leaf node
		{
			g_DictNodeByUID.Remove(node.UID);
			this.spliceNode(node);
			delete node;//maybe garbage collecter will do this?not sure
		}
	}
	this.removeNodesUnder=function(oNode, conditionstr, bCloseAction)
	//conditionstr	=null: only one node; 'true': closeAll; other: conditionally
	//also responsible to clear empty groups
	{
		var pNode=oNode.Parent;
		this.removeNodesUnderBase(oNode, conditionstr,bCloseAction);
		if(this.bClearEmptyFolders)this.clearEmptyAncestorFolders(pNode);
		this.v_postRemoveNodesUnder(pNode);
	}
	this.removeNodesUnderBase=function(oNode, conditionstr,bCloseAction)
	{
		if(conditionstr!=null)
		{
			for(var i=oNode.Child.length-1;i>=0;i--)
				this.removeNodesUnderBase(oNode.Child[i],conditionstr,bCloseAction);
		}
		if(conditionstr==null || eval(conditionstr) || (this.bClearEmptyFolders && oNode.URL==null && !oNode.hasChild())) 
//		if(conditionstr==null || eval(conditionstr))
		{
			if(bCloseAction) oNode.v_closeAction();
			this.removeNode(oNode);
		}
	}
	this.moveNode=function(sNode,dNode,pos)
	{
		var idx=dNode.getRelativeIndex();if(idx<0)return;
		var pNode;
//		alert(sNode.Title+'\n'+dNode.Title+'\n'+pos);
		this.spliceNode(sNode);//doesnt really delete it from the memory
		if(pos==0)
		{
			pNode=dNode;
			pNode.Child.push(sNode);//add to last
		}
		else
		{
			if(pos==1)idx++;
			pNode=dNode.Parent;
			if(pNode==null){alert('fatal error');return;}
			pNode.Child.splice(idx,0,sNode);//insert
		}
		sNode.Parent=pNode;
		this.v_postMoveNode(sNode,dNode,pos);
		this.bTreeChanged=true;
	}
	this.importSubTree=function(pnode,list,idx,bRestoreState)
	{
		var len=list.length;
		if(idx>=len)return true;
		var curlev=parseInt(list[idx][0]);
		var lev;
		var newnode=null;
		while(idx<len)
		{
			lev=parseInt(list[idx][0]);
			if(lev==curlev)
			{
				newnode=pnode.v_importNode(list[idx],bRestoreState);
				if(newnode==null)
				{
//					alert('import node failed');
					return false;
				}
			}
			else if(lev<curlev)
			{
				while(curlev>lev)
				{
					pnode=pnode.Parent;
					curlev--;
				}
				if(pnode==null){/*alert('invalid tree format 3');*/return false;}
				if(this.importSubTree(pnode,list,idx,bRestoreState)) return true;
				else return false;
			}	
			else if(lev==curlev+1)
			{
				if(newnode==null){/*alert('invalid tree format 2');*/return false;}
				if(this.importSubTree(newnode,list,idx,bRestoreState))return true;
				else return false;
			}
			else{/*alert('invalid tree format 1');*/return false;}
			idx++;
		}
		return true;
	}
	this.IMGTD=function(fname,icotype,idstr,filterstr)
	{
		var str;
		str= '<TD ID=TD'+icotype+idstr+' class=StyleIMGTD>';
		str+='<img src=images/'+fname;
		str+=' ID="'+icotype+idstr+'"  style="';
		if(filterstr!='') str+='filter:'+filterstr+';';
		str+='"></TD>';
		return str;
	}
	this.appendIMGTD=function(fname,icotype,idstr,filterstr,oStr)
	{
		oStr.Append('<TD ID=TD');
		oStr.Append(icotype);
		oStr.Append(idstr);
		oStr.Append(' class=StyleIMGTD>');
		oStr.Append('<img src=images/');
		oStr.Append(fname);
		oStr.Append(' ID="');
		oStr.Append(icotype);
		oStr.Append(idstr);
		oStr.Append('"  style="');
		if(filterstr!='')
		{
			oStr.Append('filter:');
			oStr.Append(filterstr);
		}
		oStr.Append('"></TD>');
	}
	this.appendSubTreeHTML=function(SubTree, LeftTDStr,level,oStr)//recursive
	{
		//Implementation of appendSubTreeHTML() starts
		var uidstr=(SubTree.UID).toString();
		var uid=SubTree.UID;
		if(SubTree.v_isHidden())return '';
		if(!(this.bShowRoot==0 && SubTree.Parent==null))
		{
			oStr.Append('<TABLE id="TBL');
			oStr.Append(SubTree.UID);
			oStr.Append('" class=StyleSubTable border=0 cellspacing=0 cellpadding=0 width=100%><TR>');
			oStr.Append(LeftTDStr);
			if (this.bShowLine==1/* && level>(1-this.bShowRoot)*/)
			{
				if(SubTree.hasChild()||SubTree.Parent==null)this.appendIMGTD(SubTree.getCONIcon(),'CON',uidstr,'',oStr);
				else this.appendIMGTD(SubTree.getCONIcon(),'','','',oStr);
			}
//			if(level>(1-this.bShowRoot))
			{
			if(this.bShowLine==0 ||SubTree.isLastChild()) LeftTDStr+=this.IMGTD('tree/ftv2blank.gif','','','');
			else	LeftTDStr+=this.IMGTD('tree/ftv2vertline.gif','','','');
			}
			//checkbox
			if(this.bCheckTree)
			{
				oStr.Append('<TD><INPUT type=checkbox id=CHK');
				oStr.Append(uidstr);
				if(SubTree.bChecked) oStr.Append(' checked ');
				else			oStr.Append('  '); 
				oStr.Append(' class=StyleCheckBox HIDEFOCUS></TD>');
			}
			this.appendIMGTD(SubTree.v_getNodeIcon(),'ICO',uidstr,SubTree.v_getFilterStr(),oStr);
			//text
			oStr.Append('<TD ID=TXA'+uidstr + ' align=left  CLASS=');
			oStr.Append(SubTree.v_getStyleClassName());
			oStr.Append(' title="');
			oStr.Append(SubTree.v_getToolTip());
			oStr.Append('">');
			oStr.Append('<SPAN ID=TXT');
			oStr.Append(uidstr);
			oStr.Append(' align=left>');
			oStr.Append(SubTree.v_getNodeText());
			oStr.Append('</SPAN><SPAN ID=TXE');
			oStr.Append(uidstr);
			oStr.Append(' align=left  CLASS=StyleTabExtra>');
			oStr.Append(SubTree.v_getExtraStr());
			oStr.Append('</SPAN></TD></TR></TABLE>\n');
		}	
		if(SubTree.hasChild())//has child
		{
			oStr.Append('<DIV ID=CLD');
			oStr.Append(uidstr);
			if(SubTree.bExpand==1) oStr.Append(' style="display:block">');
			else oStr.Append(' style="display:none">');	
			var i;
			for(i=0;SubTree.Child && i<SubTree.Child.length;i++)
			{
				this.appendSubTreeHTML(SubTree.Child[i],LeftTDStr,level+1,oStr);
			}
			oStr.Append('</DIV>\n');
		}
	}//end of function appendSubTreeHTML()
	this.getTreeDIVHTML=function()
	{
		var tt1=getCurTime()
		var oStr=CreateFastString(5000);
		oStr.Append('<DIV ID=TREEDIV CLASS=StyleTreeDiv>');//0000000000000
		this.appendSubTreeHTML(this.TreeRoot,'',0,oStr);
		var tt2=getCurTime()
//		dumpMsg('getTreeDIVHTML time='+(tt2-tt1));
		return oStr.concat();
	}
	this.getObjPos=function(objstr)
	{
		var xy=new Array();
		var obj=this.getObj(objstr);	
		if(obj==null)return null;
		xy.x=obj.offsetLeft;
		xy.y=obj.offsetTop;
		while((obj=obj.offsetParent)!=null)
		{	
			xy.x+=obj.offsetLeft+obj.clientLeft-obj.scrollLeft;
			xy.y+=obj.offsetTop+obj.clientTop-obj.scrollTop;
		}
		return xy;
	}
	this.clearDrop=function() { if(this.lastDropNode){this.lastDropNode.redrawStyle();this.lastDropNode=null;} }
	this.clearHover=function() { if(this.lastHoverNode){this.lastHoverNode.redrawStyle();this.lastHoverNode=null;} }
	this.clearSelect=function() { if(this.lastSelectNode){this.lastSelectNode.redrawStyle();this.lastSelectNode=null;} }
	this.onMouseOut=function()
	{
		if(this.v_isDisabled()) return false;
		this.clearDrop();
		this.clearHover();
		try{this.v_onMouseOut();}catch(e){}
		return false;
	}
	this.onMouseOver=function()
	{
		if(this.v_isDisabled())return false;
		try{this.v_onMouseOver();}catch(e){}
		var dlg=this.Dlg;
		var e0=dlg.event.srcElement;
		var type=e0.id.substr(0,3);
		if(!isNodeType(type)) return false;
		var uidstr=e0.id.substr(3);
		var node;
		if(g_mouse.state==0)
		{
			node=getNodeByUID(parseInt(uidstr));if(node==null) return false;
			node.v_onSetHover();
			return false;
		}
		if(g_mouse.state==1 && this.bDraggable)
		{
			node=getNodeByUID(parseInt(uidstr));
			if(node!=null && node!=g_mouse.lastDownNode && g_mouse.lastDownNode.v_isDraggable())
			{
				g_mouse.state=2;
				g_mouse.gesture.reset();
			}
			else return false;
		}
		if(g_mouse.state==2) this.onDragging();
		return false;
	}
	this.onMouseDown=function()
	{
	  g_popMenus.checkClosePopMenus();
	  if(this.v_isDisabled())return false;
	  if(g_mouse.lastButton!=0)g_mouse.reset();//reset previous pushed button
	  var dlg=this.Dlg;
	  g_mouse.lastButton=dlg.event.button;
	  var e0=dlg.event.srcElement;
	  var type=e0.id.substr(0,3);
	  if(!isNodeType(type))
	  {
		g_mouse.reset();
		return false;
	  }
	  g_mouse.gesture.reset();
	  var tnode=getNodeByUID(parseInt(e0.id.substr(3)));if(tnode==null)return false;
	  if(g_mouse.state==0)//reseted
	  {
		g_mouse.lastDownNode=tnode;
		g_mouse.state=1;
		if(isTextType(type)) g_mouse.gesture.SetStartPoint(dlg.event.x,dlg.event.y);
	  }	
	  return false;
	}
	this.onMouseUp=function()
	{
	  g_popMenus.checkClosePopMenus();
	  if(this.v_isDisabled())return false;
	  var dlg=this.Dlg;
	  var e0=dlg.event.srcElement;
	  var type=e0.id.substr(0,3);
	  if(g_mouse.lastButton!=dlg.event.button||!isNodeType(type))
	  {
		g_mouse.reset();
	        this.hideDragIcons();
		return false;
	  }
	  var uid=parseInt(e0.id.substr(3));
	  var tnode=getNodeByUID(uid);if(tnode==null)return false;
	  if(g_mouse.state==1 || g_mouse.state==0)//has not moved out the current tab
	  {
		var gstr=g_mouse.getGesture();
		if(gstr!='')
		{  
			if(isTextType(type))this.v_onGesture(tnode,gstr,g_mouse.lastButton);
		}
		else
		{	
			if(g_mouse.lastDownNode==tnode)
			{
				this.onClick(type,tnode.UID,g_mouse.lastButton);
				if(g_mouse.dblClickTimerID!=null)
				{
					if(tnode.UID==g_mouse.dblClickLastUID)
						try{this.v_onDblClick(tnode,type,g_mouse.lastButton);}catch(e){}
				}
				else g_mouse.startDblClickTimer(tnode);
			}
		}
	  }
	  else if(g_mouse.state==2)//dragging
	  {
	      if(this.dropNode!=null) this.v_onDrop(g_mouse.lastDownNode,this.dropNode,this.dropPos);
	      tnode.redrawStyle();
	  }
	  this.hideDragIcons();
	  g_mouse.reset();
	  var bchecked,obj=this.getObj('CHK'+uid);
	  if(obj)
	  {
		bchecked=(tnode.bChecked)?true:false;
//		if(bchecked!=obj.checked) obj.checked=bchecked;
	  }
	  return false;
	}
	this.hideDragIcons=function()
	{
		var obj;
		obj=this.getObj('dragTxt');
		if(obj) obj.style.visibility = "hidden";
		obj=this.getObj('dragSep');
		if(obj) obj.style.visibility = "hidden";
	}
	this.onClick=function(type,uid,lastButton)
	{
		g_popMenus.checkClosePopMenus();
		var node=getNodeByUID(uid);
		if(node==null)return;
		if(lastButton==1)
		{
			if(this.bSelectOnly==1 && isTextType(type)) node.setSelect();	
			if(type=='CHK' || this.bCheckTree && isTextType(type))
			{
				var bb;
				var obj=this.getObj('CHK'+uid);
				if(obj)
				{
					if(obj.checked)	bb=0;
					else		bb=1;
					if(isTextType(type)) node.check(bb);
					else		
					{
						node.checkAll(bb);
						obj.checked=!(obj.checked);
					}
				}
			}
			else if(node.v_isFoldable(type))
			{
				node.bExpand=1-node.bExpand;
				node.redrawNode();
				node.redrawStyle();
			}
		}
		this.v_onClick(node,type,lastButton);
		return;
	}
	/*
	  ________ 
	 |        |
	 |    (up:possiblly dblclk!)
	 | (over/out:hover)
	 |        |
	 |        |
	  ------->0-(down)-->1---(out to diff node)-->2
		  A          |                        |
		  |  (up:click or gesture)        (up:drop)
		  |          |                        |
		  |__________|________________________|
	*/
	this.onDragging=function()
	{
		var dlg=this.Dlg;
		var x=dlg.event.clientX;
		var y=dlg.event.clientY;
		var obj=dlg.event.srcElement;
		if(!obj)return;
		var oy=dlg.event.offsetY;
		var l=this.posTREEDIV.x;
		var t=this.posTREEDIV.y;
		var objtreediv=this.getObj('TREEDIV');
		var r=l+objtreediv.clientWidth;
		var b=t+objtreediv.clientHeight;
	/* scroll when mouse on the edge*/
		var m=5;
		if(y<t+m) objtreediv.scrollTop-=10;
		else if(y>b-m) objtreediv.scrollTop+=10;
		if(x<l+m) objtreediv.scrollLeft-=10;
		else if(x>r-m) objtreediv.scrollLeft+=10;
	/* setdrop */
		var type=obj.id.substr(0,3);
		if(!isNodeType(type))
		{
			this.hideDragIcons();
			this.dropNode=null;
			return;
		}
		var uidstr=obj.id.substr(3);
		obj=this.getObj('TBL'+uidstr);
		if(!obj)return;
		var t0=obj.offsetTop-objtreediv.scrollTop+objtreediv.clientTop+t;
		var l0=obj.offsetLeft-objtreediv.scrollLeft+objtreediv.clientLeft+l;
		var b0=t0+obj.offsetHeight-1;
		var node=getNodeByUID(parseInt(uidstr));
		var objtxa=this.getObj('TXA'+uidstr);
		if(objtxa)lico=objtxa.offsetLeft+obj.clientLeft-obj.scrollLeft+l0;
		else	lico=0;
		var objdragSep=this.getObj('dragSep');
		var objdragTxt=this.getObj('dragTxt');
		objdragSep.style.left=lico-dlg.document.body.clientLeft-this.offsetDragSep.x;
		if(!objdragSep || !objdragTxt)return;
		
		if(oy<obj.offsetHeight/3)
		{
			objdragSep.style.top=t0-1-dlg.document.body.clientTop-this.offsetDragSep.y;
			node.setDrop(-1);
		}
		else if(oy>obj.offsetHeight*2/3)
		{
			objdragSep.style.top=b0-dlg.document.body.clientTop-this.offsetDragSep.y;
			node.setDrop(1);
		}
		else	node.setDrop(0);
		objdragTxt.style.left=dlg.document.body.scrollLeft +x+10-this.offsetDragTxt.x;
		objdragTxt.style.top=dlg.document.body.scrollTop + y+10-this.offsetDragTxt.y;
		objdragTxt.innerText='  '+g_mouse.lastDownNode.Title;
		objdragTxt.style.visibility = "visible";
		return;
	}
	this.onMouseMove=function()
	{
		var dlg=this.Dlg;
	  	if(this.v_isDisabled())return false;
		if(g_mouse.state==1) g_mouse.gesture.onMouseMove(dlg.event.x,dlg.event.y);
		if(g_mouse.state==2)
		{
			if(dlg.event.button!=1)
			{
				g_mouse.state=0;
				this.hideDragIcons();
				return true;
			}
			return this.onDragging();
		}
		else	return true; 
	}
	this.onMouseWheel=function()
	{	
		g_popMenus.checkClosePopMenus();
	  	if(this.v_isDisabled())return false;
		var dlg=this.Dlg;
		var e0=dlg.event.srcElement;
		var type=e0.id.substr(0,3);
	    if(!isNodeType(type)) return false;
		var uidstr=e0.id.substr(3);
		var delta=-dlg.event.wheelDelta/120;
		var node=getNodeByUID(parseInt(uidstr));
		if(node==null) return false;
		if (delta > 0) {if(g_mouse.wheelDir<0) g_mouse.wheelDir=0;g_mouse.wheelDir++;}
		else if (delta <0) {if(g_mouse.wheelDir>0)g_mouse.wheelDir=0;g_mouse.wheelDir--;}
		else return false;
		try{this.v_onMouseWheel(node,type,delta);}catch(e){}
		return false;
	}
	this.onContextMenu=function() 
	{
		if(this.Dlg.event.ctrlKey){return true;}
		g_popMenus.checkClosePopMenus();
	  	if(this.v_isDisabled())return false;
		var oMenu=null;
		var dlg=this.Dlg;
		var idstr=dlg.event.srcElement.id;
		var type=idstr.substr(0,3);
		var uidstr=idstr.substr(3,idstr.length-3);
		if(!isNodeType(type) && type!='TRE') return false;	
		if(type=='TRE')oMenu=this.v_getUpdatedContextMenu(type);
		else
		{
			var node=getNodeByUID(parseInt(uidstr));
			if(node==null)return false;
			oMenu=this.v_getUpdatedContextMenu(type,node);
		}
		if(oMenu)
		{
			oMenu.show(dlg.event.screenX,dlg.event.screenY);
			this.lastRightClickedItemStr=idstr;
			g_popMenus.lastMenu=oMenu;
		}
		return false;
	}
	this.getDragOffset=function(objID)
	{
		var obj=this.getObj(objID);
		obj.style.visibility = "hidden";	
		obj.style.top=0;
		obj.style.left=0;
		var pos=this.getObjPos(objID);
		var xy=[];
		xy.x=pos.x-parseInt(obj.style.left)-this.Dlg.document.body.scrollLeft;
		xy.y=pos.y-parseInt(obj.style.top)-this.Dlg.document.body.scrollTop;
		return xy;
	}
	this.refreshTree=function(bChanged,bForce)
	{
		if(!(this.v_needRefresh(bChanged, bForce))) return;
		var oDiv=this.getObj('TREEDIV');
		this.lastActiveOffsetLeft=(oDiv==null)?0:(oDiv.scrollLeft);
		this.lastActiveOffsetTop =(oDiv==null)?0:(oDiv.scrollTop);
		var bodyHtml=this.generateBodyHTML();
		if(!("body" in this.Dlg.document) || this.Dlg.document.body==null)this.Dlg.document.write(bodyHtml);
		else this.Dlg.document.body.innerHTML=bodyHtml;
		oDiv=this.getObj('TREEDIV');
		if(oDiv)
		{
			oDiv.scrollLeft=this.lastActiveOffsetLeft;
			oDiv.scrollTop=this.lastActiveOffsetTop;
		}
		else	dumpMsg('TREEDIV doesnt exist');
		this.posTREEDIV=this.getObjPos('TREEDIV');
		var oTxt=this.getObj('dragTxt');
		var oSep=this.getObj('dragSep');
		if(!oTxt || !oSep)//create
		{
			oTxt=this.Dlg.document.createElement("DIV");
			oTxt.className="StyleDragIconDiv";
			oTxt.id='dragTxt';
			this.Dlg.document.body.appendChild(oTxt);
			oSep=this.Dlg.document.createElement("IMG");
			oSep.className="StyleDragSepDiv";
			oSep.id='dragSep';
			oSep.src='images/line.gif';
			this.Dlg.document.body.appendChild(oSep);
		}
		this.offsetDragTxt=this.getDragOffset('dragTxt');
		this.offsetDragSep=this.getDragOffset('dragSep');
		this.v_postRefreshTree();
		if(!('g_bEventAttached' in this.Dlg) || this.Dlg.g_bEventAttached!='1')	
		{
			var oDoc=this.Dlg.document;
			oDoc.ondragstart = nullHandler;
			oDoc.ondrag = nullHandler;
			oDoc.onmouseup=new Function("return "+this.refName+".onMouseUp()");
			oDoc.onmousedown=new Function("return "+this.refName+".onMouseDown()");
			oDoc.onmouseout=new Function("return "+this.refName+".onMouseOut()");
			oDoc.onmouseover=new Function("return "+this.refName+".onMouseOver()");
			oDoc.onmousemove=new Function("return "+this.refName+".onMouseMove()");
			oDoc.onmousewheel=new Function("return "+this.refName+".onMouseWheel()");
			oDoc.oncontextmenu=new Function("return "+this.refName+".onContextMenu()");
			this.Dlg.g_bEventAttached='1';
		}
		this.bTreeChanged=false;
	}
	this.onPopMenuUnload=function()
	{
		this.clearHover();
		try{	this.lastSelectNode.setSelect(false);
			this.lastSelectNode.redrawStyle();}catch(e){}
		return false;
	}
}//end of CTree

